#ifndef included
#error This script can only be compiled as a #include
#endif

#ifndef __ATTRIBS_M
#define __ATTRIBS_M

#include <lib/config.mi>

// -----------------------------------------------------------------------------------------------------------------

// this is the page that maps its items to the options menu, you can add attribs or more pages (submenus)
#define CUSTOM_OPTIONSMENU_ITEMS "{1828D28F-78DD-4647-8532-EBA504B8FC04}"

// this is the page that maps its items to the windows menu (aka View), you can add attribs or more pages (submenus)
#define CUSTOM_WINDOWSMENU_ITEMS "{6559CA61-7EB2-4415-A8A9-A2AEEF762B7F}"

// custom options submenu item page, you can add more, just use guidgen and Config.newItem()
#define CUSTOM_PAGE "{26E26319-AECA-4433-B8F1-F4A5BF2A9ED5}"

// player modes page
#define CUSTOM_PAGE_PMODES "{446F0A47-25AB-4480-9F67-8ABA1513A05E}"

// menubars config page
#define CUSTOM_PAGE_MENUBARS "{12ED320E-6813-45ac-9F8E-78EE5B2B5F6D}"

// notifier config page
#define CUSTOM_PAGE_NOTIFIER "{1AB968B3-8687-4a35-BA70-FCF6D92FB57F}"

// songticker config page
#define CUSTOM_PAGE_SONGTICKER "{7061FDE0-0E12-11D8-BB41-0050DA442EF3}"

// wheel control config page
#define CUSTOM_PAGE_WHEEL "{30D2AA12-7052-4517-91EB-34276E0297ED}"

// lights control config page
#define CUSTOM_PAGE_LIGHTS "{4B5D6C21-C87A-4126-BE4D-23A83B8AD6BE}"

// party! mode control config page
#define CUSTOM_PAGE_PARTY "{62A78A44-3309-498C-89FA-7B2535004F24}"

// non exposed attribs page
#define CUSTOM_PAGE_NONEXPOSED "{E9C2D926-53CA-400f-9A4D-85E31755A4CF}"


// -----------------------------------------------------------------------------------------------------------------

Function initAttribs();

// -----------------------------------------------------------------------------------------------------------------

Global ConfigAttribute scrolldrawerattrib;
Global ConfigAttribute scrollconfigdrawerattrib;

Global ConfigAttribute eq_visible_attrib;

Global ConfigAttribute pmode_normal_attrib;
Global ConfigAttribute pmode_stick_attrib;
Global ConfigAttribute pmode_shade_attrib;
Global ConfigAttribute pmode_party_attrib;

Global ConfigAttribute menubar_pe_attrib;
Global ConfigAttribute menubar_ml_attrib;

Global ConfigAttribute wheel_vol_attrib;
Global ConfigAttribute wheel_seek_attrib;
Global ConfigAttribute wheel_bass_attrib;
Global ConfigAttribute wheel_treble_attrib;
Global ConfigAttribute wheel_bal_attrib;

Global ConfigAttribute lights_off_attrib;
Global ConfigAttribute lights_on_attrib;
Global ConfigAttribute lights_beat_attrib;
Global ConfigAttribute lights_revbeat_attrib;

Global ConfigAttribute lights_srcVU_attrib;
Global ConfigAttribute lights_srcBass_attrib;
Global ConfigAttribute lights_srcTreble_attrib;

Global ConfigAttribute party_PL_attrib;
Global ConfigAttribute party_ML_attrib;
Global ConfigAttribute party_AVS_attrib;
Global ConfigAttribute party_VID_attrib;
Global ConfigAttribute party_bars_attrib;
Global ConfigAttribute party_osc_attrib;
Global ConfigAttribute party_off_attrib;
Global ConfigAttribute party_vis_attrib; // hidden attrib
Global ConfigAttribute party_ct_attrib;
Global ConfigAttribute party_EQ_attrib;
Global ConfigAttribute party_analClock_attrib;
Global ConfigAttribute party_digitClock_attrib;

Global ConfigAttribute notifier_minimized_attrib;
Global ConfigAttribute notifier_windowshade_attrib;
Global ConfigAttribute notifier_always_attrib;
Global ConfigAttribute notifier_never_attrib;
Global ConfigAttribute notifier_fadeintime_attrib;
Global ConfigAttribute notifier_fadeouttime_attrib;
Global ConfigAttribute notifier_holdtime_attrib;
Global ConfigAttribute notifier_disablefullscreen_attrib;
Global ConfigAttribute notifier_showend_attrib;

Global ConfigAttribute notifier_location_topright_attrib;
Global ConfigAttribute notifier_location_topleft_attrib;
Global ConfigAttribute notifier_location_bottomright_attrib;
Global ConfigAttribute notifier_location_bottomleft_attrib;

Global ConfigAttribute notifier_cdcover_attrib;

Global ConfigAttribute songticker_anunaki_attrib;
Global ConfigAttribute songticker_classicscroll_attrib;
Global ConfigAttribute songticker_classicnoscroll_attrib;

Global ConfigAttribute aot_attrib;


// -----------------------------------------------------------------------------------------------------------------

initAttribs() {

	// create the custom cfgpage for this session (if it does exist, it just returns it)
	ConfigItem custom_page = Config.newItem("Anunaki", CUSTOM_PAGE);
	ConfigItem custom_page_pmodes = Config.newItem("Player Modes", CUSTOM_PAGE_PMODES);
	ConfigItem custom_page_menubars = Config.newItem("Menus", CUSTOM_PAGE_MENUBARS);
	ConfigItem custom_page_songticker = Config.newItem("Songticker", CUSTOM_PAGE_SONGTICKER);
	ConfigItem custom_page_wheel = Config.newItem("Main Wheel Control", CUSTOM_PAGE_WHEEL);
	ConfigItem custom_page_lights = Config.newItem("Lights Control", CUSTOM_PAGE_LIGHTS);
	ConfigItem custom_page_party = Config.newItem("Party! Mode", CUSTOM_PAGE_PARTY);
	ConfigItem custom_page_notifier = Config.newItem("Notifications", CUSTOM_PAGE_NOTIFIER);

	ConfigItem custom_page_nonexposed = Config.newItem("Hidden", CUSTOM_PAGE_NONEXPOSED);

	// load up the cfgpage in which we'll insert our custom page
	ConfigItem custom_options_page = Config.getItem(CUSTOM_OPTIONSMENU_ITEMS);
	ConfigItem custom_windows_page = Config.getItem(CUSTOM_WINDOWSMENU_ITEMS);

	// this creates a submenu for this attribute
	ConfigAttribute submenuattrib = custom_options_page.newAttribute("Anunaki", "");
	submenuattrib.setData(CUSTOM_PAGE); // discard any default value and point at our custom cfgpage

	ConfigAttribute pmodessubmenu = custom_page.newAttribute("Player Modes", "");
	pmodessubmenu.setData(CUSTOM_PAGE_PMODES);

	ConfigAttribute menubarssubmenu = custom_page.newAttribute("Menus", "");
	menubarssubmenu.setData(CUSTOM_PAGE_MENUBARS);

	ConfigAttribute songtickersubmenu = custom_page.newAttribute("Songticker", "");
	songtickersubmenu.setData(CUSTOM_PAGE_SONGTICKER);

	ConfigAttribute wheelsubmenu = custom_page.newAttribute("Main Wheel Control", "");
	wheelsubmenu.setData(CUSTOM_PAGE_WHEEL);

	ConfigAttribute lightssubmenu = custom_page.newAttribute("Lights Control", "");
	lightssubmenu.setData(CUSTOM_PAGE_LIGHTS);

	ConfigAttribute partysubmenu = custom_page.newAttribute("Party! Mode", "");
	partysubmenu.setData(CUSTOM_PAGE_PARTY);

	ConfigAttribute notifiersubmenu = custom_page.newAttribute("Notifications", "");
	notifiersubmenu.setData(CUSTOM_PAGE_NOTIFIER);

	ConfigAttribute sep,sep2;
	eq_visible_attrib = custom_windows_page.newAttribute("Equalizer\tAlt+G", "0");

	pmode_normal_attrib = custom_page_pmodes.newAttribute("Normal", "0");
	pmode_stick_attrib = custom_page_pmodes.newAttribute("Stick", "0");
	pmode_shade_attrib = custom_page_pmodes.newAttribute("Shade", "0");
	pmode_party_attrib = custom_page_pmodes.newAttribute("Party!", "0");

	menubar_pe_attrib = custom_page_menubars.newAttribute("Show Menus in Playlist Editor", "1");
	menubar_ml_attrib = custom_page_menubars.newAttribute("Show Menus in Media Library", "1");

	songticker_classicnoscroll_attrib = custom_page_songticker.newAttribute("Classic No Scroll", "0");
	songticker_classicscroll_attrib = custom_page_songticker.newAttribute("Classic Scroll", "0");
	songticker_anunaki_attrib = custom_page_songticker.newAttribute("Anunaki Songticker", "1");

	wheel_vol_attrib = custom_page_wheel.newAttribute("Volume", "1");
	wheel_seek_attrib = custom_page_wheel.newAttribute("Seeker", "0");
	wheel_bass_attrib = custom_page_wheel.newAttribute("Bass", "0");
	wheel_treble_attrib = custom_page_wheel.newAttribute("Treble", "0");
	wheel_bal_attrib = custom_page_wheel.newAttribute("Balance", "0");

	lights_off_attrib = custom_page_lights.newAttribute("Off", "1");
	lights_on_attrib = custom_page_lights.newAttribute("Stay On", "0");
	lights_beat_attrib = custom_page_lights.newAttribute("Beat (High CPU)", "0");
	lights_revbeat_attrib = custom_page_lights.newAttribute("Reversed Beat (High CPU)", "0");
	sep = custom_page_lights.newAttribute("sep1", ""); sep.setData("-");
	lights_srcVU_attrib = custom_page_lights.newAttribute("Beat Source: VU Meter", "1");
	lights_srcBass_attrib = custom_page_lights.newAttribute("Beat Source: Bass", "0");
	lights_srcTreble_attrib = custom_page_lights.newAttribute("Beat Source: Treble", "0");

	party_PL_attrib = custom_page_party.newAttribute("Playlist", "1");
	party_ML_attrib = custom_page_party.newAttribute("Media Library", "0");
	sep = custom_page_party.newAttribute("sep1", ""); sep.setData("-");
	party_AVS_attrib = custom_page_party.newAttribute("Visualization", "0");
	party_VID_attrib = custom_page_party.newAttribute("Video", "0");
	party_bars_attrib = custom_page_party.newAttribute("Spectrum Analyzer", "1");
	party_osc_attrib = custom_page_party.newAttribute("Oscilloscope", "0");
	party_off_attrib = custom_page_party.newAttribute("All Vis Off", "0");
	sep2 = custom_page_party.newAttribute("sep2", ""); sep2.setData("-");
	party_ct_attrib = custom_page_party.newAttribute("Colors", "1");
	party_EQ_attrib = custom_page_party.newAttribute("Equalizer", "1");
	party_analClock_attrib = custom_page_party.newAttribute("Analog Clock", "1");
	party_digitClock_attrib = custom_page_party.newAttribute("Digital Clock", "0");

	party_vis_attrib = custom_page_nonexposed.newAttribute("Visuals", "1");

	// create an attribute for each of our options, if the attribute already exists, it is returned
	//sep = custom_page.newAttribute("sep1", ""); sep.setData("-");

	notifier_always_attrib = custom_page_notifier.newAttribute("Show always", "0");
	notifier_windowshade_attrib = custom_page_notifier.newAttribute("Show with stick, shade and when minimized", "0");
	notifier_minimized_attrib = custom_page_notifier.newAttribute("Show only when minimized", "0");
	notifier_never_attrib = custom_page_notifier.newAttribute("Never show", "1");
	sep = custom_page_notifier.newAttribute("sep1", ""); sep.setData("-");
	notifier_location_topright_attrib = custom_page_notifier.newAttribute("Location: Top Right", "0");
	notifier_location_topleft_attrib = custom_page_notifier.newAttribute("Location: Top Left", "0");
	notifier_location_bottomright_attrib = custom_page_notifier.newAttribute("Location: Bottom Right", "1");
	notifier_location_bottomleft_attrib = custom_page_notifier.newAttribute("Location: Bottom Left", "0");
	sep = custom_page_notifier.newAttribute("sep2", ""); sep.setData("-");
	notifier_cdcover_attrib = custom_page_notifier.newAttribute("Show CD Cover", "0");
	notifier_disablefullscreen_attrib = custom_page_notifier.newAttribute("Disable in fullscreen", "1");
	notifier_showend_attrib = custom_page_notifier.newAttribute("Show again at end of track", "1");

	notifier_fadeintime_attrib = custom_page_nonexposed.newAttribute("Notifications fade in time", "1000");
	notifier_fadeouttime_attrib = custom_page_nonexposed.newAttribute("Notifications fade out time", "5000");
	notifier_holdtime_attrib = custom_page_nonexposed.newAttribute("Notifications display time", "2000");


}

// -----------------------------------------------------------------------------------------------------------------

#define NOOFF if (getData()=="0") { setData("1"); return; }


Global Int attribs_mychange;

// **** the following function def will be redefined "outside" of attribs.m 
// 	and is called whenever an update to certain attribs happens

function SkinOptionsMenuToggle();

// fake/emulated skin options menu :)
SkinOptionsMenuToggle() {
  popupMenu skinoptionsMenu;
  popupMenu pmodesSubmenu;
  popupMenu menusSubmenu;
  popupMenu songtickerSubmenu;
  popupMenu wheelSubmenu;
  popupMenu lightsSubmenu;
  popupMenu partySubmenu;
  popupMenu notifications;

  pmodesSubMenu = new popUpMenu;
  pmodesSubMenu.addCommand("Normal", 701, stringToInteger(pmode_normal_attrib.getData()), 0);
  pmodesSubMenu.addCommand("Stick", 702, stringToInteger(pmode_stick_attrib.getData()), 0);
  pmodesSubMenu.addCommand("Shade", 703, stringToInteger(pmode_shade_attrib.getData()), 0);
  pmodesSubMenu.addCommand("Party!", 704, stringToInteger(pmode_party_attrib.getData()), 0);

  menusSubMenu = new popUpMenu;
  menusSubMenu.addCommand("Show Menus in Playlist Editor", 101, stringToInteger(menubar_pe_attrib.getData()), 0);
  menusSubMenu.addCommand("Show Menus in Media Library", 102, stringToInteger(menubar_ml_attrib.getData()), 0);

  songtickerSubmenu = new popUpMenu;
  songtickerSubmenu.addCommand("Classic No Scroll", 201, stringToInteger(songticker_classicnoscroll_attrib.getData()), 0);
  songtickerSubmenu.addCommand("Classic Scroll", 202, stringToInteger(songticker_classicscroll_attrib.getData()), 0);
  songtickerSubmenu.addCommand("Anunaki Songticker", 203, stringToInteger(songticker_anunaki_attrib.getData()), 0);

  wheelSubmenu = new popUpMenu;
  wheelSubmenu.addCommand("Volume", 301, stringToInteger(wheel_vol_attrib.getData()), 0);
  wheelSubmenu.addCommand("Seeker", 302, stringToInteger(wheel_seek_attrib.getData()), 0);
  wheelSubmenu.addCommand("Bass", 303, stringToInteger(wheel_bass_attrib.getData()), 0);
  wheelSubmenu.addCommand("Treble", 304, stringToInteger(wheel_treble_attrib.getData()), 0);
  wheelSubmenu.addCommand("Balance", 305, stringToInteger(wheel_bal_attrib.getData()), 0);

  lightsSubmenu = new popUpMenu;
  lightsSubmenu.addCommand("Off", 401, stringToInteger(lights_off_attrib.getData()), 0);
  lightsSubmenu.addCommand("Stay On", 402, stringToInteger(lights_on_attrib.getData()), 0);
  lightsSubmenu.addCommand("Beat (High CPU)", 403, stringToInteger(lights_beat_attrib.getData()), 0);
  lightsSubmenu.addCommand("Reversed Beat (High CPU)", 404, stringToInteger(lights_revbeat_attrib.getData()), 0);
  lightsSubmenu.addSeparator();
  lightsSubmenu.addCommand("Beat Source: VU Meter", 405, stringToInteger(lights_srcVU_attrib.getData()), 0);
  lightsSubmenu.addCommand("Beat Source: Bass", 406, stringToInteger(lights_srcBass_attrib.getData()), 0);
  lightsSubmenu.addCommand("Beat Source: Treble", 407, stringToInteger(lights_srcTreble_attrib.getData()), 0);

  partySubmenu = new popUpMenu;
  partySubmenu.addCommand("Playlist", 501, stringToInteger(party_PL_attrib.getData()), 0);
  partySubmenu.addCommand("Media Library", 502, stringToInteger(party_ML_attrib.getData()), 0);
  partySubmenu.addSeparator();
  partySubmenu.addCommand("Visualization", 503, stringToInteger(party_AVS_attrib.getData()), 0);
  partySubmenu.addCommand("Video", 504, stringToInteger(party_VID_attrib.getData()), 0);
  partySubmenu.addCommand("Spectrum Analyzer", 505, stringToInteger(party_bars_attrib.getData()), 0);
  partySubmenu.addCommand("Oscilloscope", 506, stringToInteger(party_osc_attrib.getData()), 0);
  partySubmenu.addCommand("All Vis Off", 507, stringToInteger(party_off_attrib.getData()), 0);
  partySubmenu.addSeparator();
  partySubmenu.addCommand("Colors", 508, stringToInteger(party_ct_attrib.getData()), 0);
  partySubmenu.addCommand("Equalizer", 509, stringToInteger(party_EQ_attrib.getData()), 0);
  partySubmenu.addCommand("Analog Clock", 510, stringToInteger(party_analClock_attrib.getData()), 0);
  partySubmenu.addCommand("Digital Clock", 511, stringToInteger(party_digitClock_attrib.getData()), 0);

  notifications = new popUpMenu;
  Notifications.addCommand(notifier_always_attrib.getAttributeName(), 601, notifier_always_attrib.getData()=="1", 0);
  Notifications.addCommand(notifier_windowshade_attrib.getAttributeName(), 602, notifier_windowshade_attrib.getData()=="1", 0);
  Notifications.addCommand(notifier_minimized_attrib.getAttributeName(), 603, notifier_minimized_attrib.getData()=="1", 0);
  Notifications.addCommand(notifier_never_attrib.getAttributeName(), 604, notifier_never_attrib.getData()=="1", 0);
  Notifications.addSeparator();
  Notifications.addCommand(notifier_location_topright_attrib.getAttributeName(), 605, notifier_location_topright_attrib.getData()=="1", 0);
  Notifications.addCommand(notifier_location_topleft_attrib.getAttributeName(), 606, notifier_location_topleft_attrib.getData()=="1", 0);
  Notifications.addCommand(notifier_location_bottomright_attrib.getAttributeName(), 607, notifier_location_bottomright_attrib.getData()=="1", 0);
  Notifications.addCommand(notifier_location_bottomleft_attrib.getAttributeName(), 608, notifier_location_bottomleft_attrib.getData()=="1", 0);
  Notifications.addSeparator();
  Notifications.addCommand(notifier_cdcover_attrib.getAttributeName(), 609, notifier_cdcover_attrib.getData()=="1", 0);
  Notifications.addCommand(notifier_disablefullscreen_attrib.getAttributeName(), 610, notifier_disablefullscreen_attrib.getData()=="1", 0);
  Notifications.addCommand(notifier_showend_attrib.getAttributeName(), 611, notifier_showend_attrib.getData()=="1", 0);

  skinoptionsMenu = new popUpMenu;
  skinoptionsMenu.addsubmenu(pmodesSubMenu,"Player Modes");
  skinoptionsMenu.addsubmenu(menusSubMenu,"Menu");
  skinoptionsMenu.addsubmenu(songtickerSubmenu,"Songticker");
  skinoptionsMenu.addsubmenu(wheelSubmenu,"Main Wheel Control");
  skinoptionsMenu.addsubmenu(lightsSubmenu,"Lights Control");
  skinoptionsMenu.addsubmenu(partySubmenu,"Party! Mode");
  skinoptionsMenu.addsubmenu(notifications,"Notifications");

  int res = skinoptionsMenu.popAtMouse();

  delete pmodesSubMenu;
  delete menusSubMenu;
  delete songtickerSubMenu;
  delete wheelSubMenu;
  delete lightsSubMenu;
  delete partySubMenu;
  delete notifications;
  delete skinoptionsMenu;

  if (res==701) pmode_normal_attrib.setData("1");
  if (res==702) pmode_stick_attrib.setData("1");
  if (res==703) pmode_shade_attrib.setData("1");
  if (res==704) pmode_party_attrib.setData("1");

  if (res==101) menubar_pe_attrib.setData(integerToString(menubar_pe_attrib.getData()=="0"));
  if (res==102) menubar_ml_attrib.setData(integerToString(menubar_ml_attrib.getData()=="0"));

  if (res==201) songticker_classicnoscroll_attrib.setData("1");
  if (res==202) songticker_classicscroll_attrib.setData("1");
  if (res==203) songticker_anunaki_attrib.setData("1");

  if (res==301) wheel_vol_attrib.setData("1");
  if (res==302) wheel_seek_attrib.setData("1");
  if (res==303) wheel_bass_attrib.setData("1");
  if (res==304) wheel_treble_attrib.setData("1");
  if (res==305) wheel_bal_attrib.setData("1");

  if (res==401) lights_off_attrib.setData("1");
  if (res==402) lights_on_attrib.setData("1");
  if (res==403) lights_beat_attrib.setData("1");
  if (res==404) lights_revbeat_attrib.setData("1");
  if (res==405) lights_srcVU_attrib.setData("1");
  if (res==406) lights_srcBass_attrib.setData("1");
  if (res==407) lights_srcTreble_attrib.setData("1");

  if (res==501) party_PL_attrib.setData(integerToString(party_PL_attrib.getData()=="0"));
  if (res==502) party_ML_attrib.setData("1");
  if (res==503) party_AVS_attrib.setData("1");
  if (res==504) party_VID_attrib.setData("1");
  if (res==505) party_bars_attrib.setData("1");
  if (res==506) party_osc_attrib.setData("1");
  if (res==507) party_off_attrib.setData("1");
  if (res==508) party_ct_attrib.setData(integerToString(party_ct_attrib.getData()=="0"));
  if (res==509) party_EQ_attrib.setData(integerToString(party_EQ_attrib.getData()=="0"));
  if (res==510) party_analClock_attrib.setData(integerToString(party_analClock_attrib.getData()=="0"));
  if (res==511) party_digitClock_attrib.setData(integerToString(party_digitClock_attrib.getData()=="0"));

  if (res == 601) notifier_always_attrib.setData("1");
  if (res == 602) notifier_windowshade_attrib.setData("1");
  if (res == 603) notifier_minimized_attrib.setData("1");
  if (res == 604) notifier_never_attrib.setData("1");
  if (res == 605) notifier_location_topright_attrib.setData("1");
  if (res == 606) notifier_location_topleft_attrib.setData("1");
  if (res == 607) notifier_location_bottomright_attrib.setData("1");
  if (res == 608) notifier_location_bottomleft_attrib.setData("1");
  if (res == 609) notifier_cdcover_attrib.setData(integerToString(notifier_cdcover_attrib.getData()=="0"));
  if (res == 610) notifier_disablefullscreen_attrib.setData(integerToString(notifier_disablefullscreen_attrib.getData()=="0"));
  if (res == 611) notifier_showend_attrib.setData(integerToString(notifier_showend_attrib.getData()=="0"));


  return;
}


#ifdef MAIN_ATTRIBS_MGR

pmode_normal_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  pmode_stick_attrib.setData("0");
  pmode_shade_attrib.setData("0");
  pmode_party_attrib.setData("0");

  attribs_mychange = 0;
}

pmode_stick_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  pmode_normal_attrib.setData("0");
  pmode_shade_attrib.setData("0");
  pmode_party_attrib.setData("0");

  attribs_mychange = 0;
}

pmode_shade_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  pmode_stick_attrib.setData("0");
  pmode_normal_attrib.setData("0");
  pmode_party_attrib.setData("0");

  attribs_mychange = 0;
}

pmode_party_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  pmode_stick_attrib.setData("0");
  pmode_shade_attrib.setData("0");
  pmode_normal_attrib.setData("0");

  attribs_mychange = 0;
}

songticker_anunaki_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  songticker_classicnoscroll_attrib.setData("0");
  songticker_classicscroll_attrib.setData("0");

  attribs_mychange = 0;
}

songticker_classicnoscroll_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  songticker_anunaki_attrib.setData("0");
  songticker_classicscroll_attrib.setData("0");

  attribs_mychange = 0;
}

songticker_classicscroll_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  songticker_classicnoscroll_attrib.setData("0");
  songticker_anunaki_attrib.setData("0");

  attribs_mychange = 0;
}

wheel_vol_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  wheel_bass_attrib.setData("0");
  wheel_treble_attrib.setData("0");
  wheel_seek_attrib.setData("0");
  wheel_bal_attrib.setData("0");

  attribs_mychange = 0;

}

wheel_seek_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  wheel_bass_attrib.setData("0");
  wheel_treble_attrib.setData("0");
  wheel_vol_attrib.setData("0");
  wheel_bal_attrib.setData("0");

  attribs_mychange = 0;

  
}

wheel_bass_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  wheel_seek_attrib.setData("0");
  wheel_treble_attrib.setData("0");
  wheel_vol_attrib.setData("0");
  wheel_bal_attrib.setData("0");

  attribs_mychange = 0;

  
}

wheel_treble_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  wheel_bass_attrib.setData("0");
  wheel_seek_attrib.setData("0");
  wheel_vol_attrib.setData("0");
  wheel_bal_attrib.setData("0");

  attribs_mychange = 0;

  
}

wheel_bal_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  wheel_bass_attrib.setData("0");
  wheel_treble_attrib.setData("0");
  wheel_vol_attrib.setData("0");
  wheel_seek_attrib.setData("0");

  attribs_mychange = 0;

  
}

lights_off_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  lights_on_attrib.setData("0");
  lights_beat_attrib.setData("0");
  lights_revbeat_attrib.setData("0");

  attribs_mychange = 0;

  
}

lights_on_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  lights_off_attrib.setData("0");
  lights_beat_attrib.setData("0");
  lights_revbeat_attrib.setData("0");

  attribs_mychange = 0;

  
}

lights_beat_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  lights_on_attrib.setData("0");
  lights_off_attrib.setData("0");
  lights_revbeat_attrib.setData("0");

  attribs_mychange = 0;

  
}

lights_revbeat_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  lights_on_attrib.setData("0");
  lights_beat_attrib.setData("0");
  lights_off_attrib.setData("0");

  attribs_mychange = 0;

  
}

lights_srcVU_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  lights_srcBass_attrib.setData("0");
  lights_srcTreble_attrib.setData("0");

  attribs_mychange = 0;

}

lights_srcBass_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  lights_srcVU_attrib.setData("0");
  lights_srcTreble_attrib.setData("0");

  attribs_mychange = 0;
  
}

lights_srcTreble_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  lights_srcBass_attrib.setData("0");
  lights_srcVU_attrib.setData("0");

  attribs_mychange = 0;
  
}

party_ML_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF

  attribs_mychange = 1;

  party_VID_attrib.setData("0");
  party_AVS_attrib.setData("0");
  party_bars_attrib.setData("0");
  party_osc_attrib.setData("0");
  party_vis_attrib.setData("0");

  attribs_mychange = 0;
}

party_VID_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF

  attribs_mychange = 1;

  party_off_attrib.setData("0");
  party_ML_attrib.setData("0");
  party_AVS_attrib.setData("0");
  party_bars_attrib.setData("0");
  party_osc_attrib.setData("0");
  party_vis_attrib.setData("1");

  attribs_mychange = 0;
}

party_AVS_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF

  attribs_mychange = 1;

  party_off_attrib.setData("0");
  party_VID_attrib.setData("0");
  party_ML_attrib.setData("0");
  party_bars_attrib.setData("0");
  party_osc_attrib.setData("0");
  party_vis_attrib.setData("1");

  attribs_mychange = 0;
}

party_bars_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF

  attribs_mychange = 1;

  party_off_attrib.setData("0");
  party_VID_attrib.setData("0");
  party_AVS_attrib.setData("0");
  party_ML_attrib.setData("0");
  party_osc_attrib.setData("0");
  party_vis_attrib.setData("1");

  attribs_mychange = 0;
}

party_osc_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF

  attribs_mychange = 1;

  party_off_attrib.setData("0");
  party_VID_attrib.setData("0");
  party_AVS_attrib.setData("0");
  party_bars_attrib.setData("0");
  party_ml_attrib.setData("0");
  party_vis_attrib.setData("1");

  attribs_mychange = 0;
}

party_off_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF

  attribs_mychange = 1;

  party_osc_attrib.setData("0");
  party_VID_attrib.setData("0");
  party_AVS_attrib.setData("0");
  party_bars_attrib.setData("0");
  party_ml_attrib.setData("0");
  party_vis_attrib.setData("1");

  attribs_mychange = 0;
}

party_vis_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF

  attribs_mychange = 1;

  if (getData() == "1") party_ml_attrib.setData("0");

  attribs_mychange = 0;
}

party_analClock_attrib.onDataChanged() {
  if (attribs_mychange) return;

  attribs_mychange = 1;

  party_digitClock_attrib.setData("0");

  attribs_mychange = 0;
}

party_digitClock_attrib.onDataChanged() {
  if (attribs_mychange) return;

  attribs_mychange = 1;

  party_analClock_attrib.setData("0");

  attribs_mychange = 0;
}

notifier_always_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  notifier_never_attrib.setData("0");
  notifier_windowshade_attrib.setData("0");
  notifier_minimized_attrib.setData("0");
  attribs_mychange = 0;
}

notifier_never_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  notifier_always_attrib.setData("0");
  notifier_windowshade_attrib.setData("0");
  notifier_minimized_attrib.setData("0");
  attribs_mychange = 0;
}

notifier_minimized_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  notifier_never_attrib.setData("0");
  notifier_windowshade_attrib.setData("0");
  notifier_always_attrib.setData("0");
  attribs_mychange = 0;
}

notifier_windowshade_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  notifier_never_attrib.setData("0");
  notifier_always_attrib.setData("0");
  notifier_minimized_attrib.setData("0");
  attribs_mychange = 0;
}

notifier_location_topright_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  notifier_location_topleft_attrib.setData("0");
  notifier_location_bottomleft_attrib.setData("0");
  notifier_location_bottomright_attrib.setData("0");
  attribs_mychange = 0;
}

notifier_location_topleft_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  notifier_location_topright_attrib.setData("0");
  notifier_location_bottomleft_attrib.setData("0");
  notifier_location_bottomright_attrib.setData("0");
  attribs_mychange = 0;
}

notifier_location_bottomright_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  notifier_location_topleft_attrib.setData("0");
  notifier_location_bottomleft_attrib.setData("0");
  notifier_location_topright_attrib.setData("0");
  attribs_mychange = 0;
}

notifier_location_bottomleft_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  notifier_location_topleft_attrib.setData("0");
  notifier_location_topright_attrib.setData("0");
  notifier_location_bottomright_attrib.setData("0");
  attribs_mychange = 0;
}

#endif

#endif
