/*
	Anunaki - buttons.m
	by Leechbite

	- button action scripts
*/

buttonsLoad() {
  buttonSHF = mainstick.findObject("Shuffle");
  buttonREP = mainstick.findObject("Repeat");
  buttonXFD = mainstick.findObject("Xfade");

  mainoptionsbutton = mainnormal.findObject("config.button.toggle");
  stickoptionsbutton = mainstick.findObject("config.button.toggle");
  group temp = mainfs.findObject("fs.button.opt");
  fsoptionsbutton = temp.getObject("anunaki.button2");

  mainlcdbutton = mainnormal.findObject("LCDButton");
  mainlcd = mainnormal.findObject("main.lcd.layouts");
  mainconcealer = mainnormal.findObject("main.lcd.concealer");
  mainconcealer.setTargetSpeed(0.50);
  mainconcealer.hide();

  sticklcdbutton = mainstick.findObject("LCDButton");
  sticklcd = mainstick.findObject("stick.lcd.layouts");
  stickconcealer = mainstick.findObject("stick.lcd.concealer");
  stickconcealer.setTargetSpeed(0.50);
  stickconcealer.hide();

  shadelcdbutton = mainshade.findObject("LCDButton");
  shadelcd = mainshade.findObject("shade.lcd.layouts");
  shadeconcealer = mainshade.findObject("shade.lcd.concealer");
  shadeconcealer.setTargetSpeed(0.50);
  shadeconcealer.hide();

  shadevolup = mainshade.findObject("vol.up");
  shadevoldown = mainshade.findObject("vol.down");
  shadevoluplabel = mainshade.findObject("vol.label.up");
  shadevoldownlabel = mainshade.findObject("vol.label.down");
  shadevoluplabel.setTargetSpeed(0.75);
  shadevoldownlabel.setTargetSpeed(0.75);

  maincurrlayout = getPrivateInt("Anunaki", "Main Layout", 1);
  stickcurrlayout = getPrivateInt("Anunaki", "Stick Layout", 1);
  shadecurrlayout = getPrivateInt("Anunaki", "Shade Layout", 1);

  aot = mainnormal.findObject("aotdummy");

  changelayout();
}

buttonsUnLoad() {
  return;
}

// *********  skin options menu *************

mainoptionsbutton.onRightButtonDown(int x, int y) {  skinoptionsmenuToggle(); complete;}
stickoptionsbutton.onRightButtonDown(int x, int y) {  skinoptionsmenuToggle(); complete; }
fsoptionsbutton.onLeftClick() {  skinoptionsmenuToggle(); }
fsoptionsbutton.onRightButtonDown(int x, int y) {  skinoptionsmenuToggle(); complete; }

// *********  main layout changer ****************

changelayout() {
  if ((maincurrlayout>=1) && (maincurrlayout<=4))
    mainlcd.setXMLParam("groupid", "main.lcd.layout"+integerToString(maincurrlayout));
  if ((stickcurrlayout>=1) && (stickcurrlayout<=3))
    sticklcd.setXMLParam("groupid", "stick.lcd.layout"+integerToString(stickcurrlayout));
  if ((shadecurrlayout>=1) && (shadecurrlayout<=3))
    shadelcd.setXMLParam("groupid", "shade.lcd.layout"+integerToString(shadecurrlayout));

  setPrivateInt("Anunaki", "Main Layout", maincurrlayout);
  setPrivateInt("Anunaki", "Stick Layout", stickcurrlayout);
  setPrivateInt("Anunaki", "Shade Layout", shadecurrlayout);

}

mainlcdbutton.onLeftClick() {
  maincurrlayout++;
  if (maincurrlayout > 4) maincurrlayout = 1;

  mainconcealer.show();
  mainconcealer.cancelTarget();
  mainconcealer.setTargetA(255);
  mainconcealer.gotoTarget();
}

mainconcealer.onTargetReached() {
  if (getAlpha() > 200) {
    changelayout();
    setTargetA(0);
    gotoTarget();
  } else {
    hide();
  }
}

mainlcdbutton.onRightButtonDown(int x, int y) {
  popUpMenu lcdmenu;

  lcdmenu = new popUpMenu;
  lcdmenu.addCommand("- Main LCD Layouts -", -1, 0, 1);
  lcdmenu.addSeparator();
  lcdmenu.addCommand(" Default", 1, maincurrlayout==1, 0);
  lcdmenu.addCommand(" Big Vis", 2, maincurrlayout==2, 0);
  lcdmenu.addCommand(" Digital Clock", 3, maincurrlayout==3, 0);
  lcdmenu.addCommand(" Analog Clock", 4, maincurrlayout==4, 0);

  int res = lcdmenu.popAtMouse();
  delete lcdmenu;

  if ((res<1) || (res>4) || (res==maincurrlayout))return;

  maincurrlayout = res;
  mainconcealer.show();
  mainconcealer.cancelTarget();
  mainconcealer.setTargetA(255);
  mainconcealer.gotoTarget();
}

// *********  stick layout changer ****************

sticklcdbutton.onLeftClick() {
  stickcurrlayout++;
  if (stickcurrlayout > 3) stickcurrlayout = 1;

  stickconcealer.show();
  stickconcealer.cancelTarget();
  stickconcealer.setTargetA(255);
  stickconcealer.gotoTarget();
}

stickconcealer.onTargetReached() {
  if (getAlpha() > 200) {
    changelayout();
    setTargetA(0);
    gotoTarget();
  } else {
    hide();
  }
}

sticklcdbutton.onRightButtonDown(int x, int y) {
  popUpMenu lcdmenu;

  lcdmenu = new popUpMenu;
  lcdmenu.addCommand("- Stick LCD Layouts -", -1, 0, 1);
  lcdmenu.addSeparator();
  lcdmenu.addCommand(" Default", 1, stickcurrlayout==1, 0);
  lcdmenu.addCommand(" Vis Bars", 2, stickcurrlayout==2, 0);
  lcdmenu.addCommand(" Digital Clock", 3, stickcurrlayout==3, 0);

  int res = lcdmenu.popAtMouse();
  delete lcdmenu;

  if ((res<1) || (res>3) || (res==stickcurrlayout)) return;

  stickcurrlayout = res;
  stickconcealer.show();
  stickconcealer.cancelTarget();
  stickconcealer.setTargetA(255);
  stickconcealer.gotoTarget();
}

// *********  shade layout changer ****************

shadelcdbutton.onLeftClick() {
  shadecurrlayout++;
  if (shadecurrlayout > 3) shadecurrlayout = 1;

  shadeconcealer.show();
  shadeconcealer.cancelTarget();
  shadeconcealer.setTargetA(255);
  shadeconcealer.gotoTarget();
}

shadeconcealer.onTargetReached() {
  if (getAlpha() > 200) {
    changelayout();
    setTargetA(0);
    gotoTarget();
  } else {
    hide();
  }
}

shadelcdbutton.onRightButtonDown(int x, int y) {
  popUpMenu lcdmenu;

  lcdmenu = new popUpMenu;
  lcdmenu.addCommand("- Shade LCD Layouts -", -1, 0, 1);
  lcdmenu.addSeparator();
  lcdmenu.addCommand(" Default", 1, shadecurrlayout==1, 0);
  lcdmenu.addCommand(" Big Vis", 2, shadecurrlayout==2, 0);
  lcdmenu.addCommand(" Analog Clock", 3, shadecurrlayout==3, 0);

  int res = lcdmenu.popAtMouse();
  delete lcdmenu;

  if ((res<1) || (res>3) || (res==shadecurrlayout))return;

  shadecurrlayout = res;
  shadeconcealer.show();
  shadeconcealer.cancelTarget();
  shadeconcealer.setTargetA(255);
  shadeconcealer.gotoTarget();
}

buttonsOnTitleChange(string newtitle) {
  if (mainshade.isVisible()) {
    if (shadecurrlayout==3) {
      setTempText(newtitle);
    }
  }
}

// ************ shade volume changer ************

shadevolup.onLeftClick() {
  if (AutoRepeat_ClickType!=0) {
    int newVol = getVolume()+3;
    if (newVol > 255) newVol = 255;
    setVolume(newVol);
  }
}

shadevoldown.onLeftClick() {
  if (AutoRepeat_ClickType!=0) {
    int newVol = getVolume()-3;
    if (newVol < 0) newVol = 0;
    setVolume(newVol);
  }
}

shadevolup.onEnterArea() {
  shadevoluplabel.setTargetA(255);
  shadevoluplabel.gotoTarget();
}

shadevolup.onLeaveArea() {
  shadevoluplabel.setTargetA(0);
  shadevoluplabel.gotoTarget();
}

shadevoldown.onEnterArea() {
  shadevoldownlabel.setTargetA(255);
  shadevoldownlabel.gotoTarget();
}

shadevoldown.onLeaveArea() {
  shadevoldownlabel.setTargetA(0);
  shadevoldownlabel.gotoTarget();
}