/*************************************************************

  Anunaki - cbutton.m
  by Leechbite

  - this script controls the control buttons (play, pause, etc.)

*************************************************************/

#include <lib/std.mi>
#include "temptext.m"

Global group frameGroup;
Global button play, pause, prev, next, stop, open;
Global guiobject playlabel, pauselabel;
Global guiObject playpauseglow, prevglow, nextglow, stopglow, openglow;
Global boolean playpauseleave, prevleave, nextleave, stopleave, openleave;

System.onScriptLoaded() {
  temptextLoad();

  frameGroup = getScriptGroup();

  play = frameGroup.findObject("play");
  pause = frameGroup.findObject("pause");
  prev = frameGroup.findObject("prev");
  next = frameGroup.findObject("next");
  stop = frameGroup.findObject("stop");
  open = frameGroup.findObject("open");

  playpauseglow = frameGroup.findObject("cbutton.glow.playpause");
  prevglow = frameGroup.findObject("cbutton.glow.prev");
  nextglow = frameGroup.findObject("cbutton.glow.next");
  stopglow = frameGroup.findObject("cbutton.glow.stop");
  openglow = frameGroup.findObject("button.glow.open");

  playpauseglow.setTargetSpeed(0.50);
  prevglow.setTargetSpeed(0.50);
  nextglow.setTargetSpeed(0.50);
  stopglow.setTargetSpeed(0.50);
  openglow.setTargetSpeed(0.50);

  playpauseleave=1; prevleave=1; nextleave=1; stopleave=1; openleave=1;

  playlabel = frameGroup.findObject("cbutton.label.play");
  pauselabel = frameGroup.findObject("cbutton.label.pause");

  if (System.getStatus() != 1) {
    Play.show();
    Pause.hide();
    Playlabel.show();
    Pauselabel.hide();
  }
  else {
    Pause.show();
    Play.hide();
    Pauselabel.show();
    Playlabel.hide();
  }
}

system.onScriptUnloading() {
  temptextUnLoad();
}

// ********* play2pause scripts **************

System.onPlay()
{
    Pause.show();
    Play.hide();
    Pauselabel.show();
    Playlabel.hide();

    setTempText(" Play");
}

System.onresume()
{
    Pause.show();
    Play.hide();
    Pauselabel.show();
    Playlabel.hide();

    setTempText(" Resume Play");
}

System.onPause()
{
    Play.show();
    Pause.hide();
    Playlabel.show();
    Pauselabel.hide();

   setTempText(" Pause");

}

System.onStop()
{
    Play.show();
    Pause.hide();
    Playlabel.show();
    Pauselabel.hide();

   setTempText(" Stop");

}

Next.onLeftClick() {
   setTempText(" Next");
}

Prev.onLeftClick() {
   setTempText(" Previous");
}

// ******** glow scripts ********************

play.onEnterArea() {
  playpauseglow.setTargetA(255);
  playpauseglow.gotoTarget();

  playpauseleave=0;
}

play.onLeaveArea() {
  playpauseglow.setTargetA(0);
  playpauseglow.gotoTarget();

  playpauseleave=1;  
}

pause.onEnterArea() {
  playpauseglow.setTargetA(255);
  playpauseglow.gotoTarget();

  playpauseleave=0;
}

pause.onLeaveArea() {
  playpauseglow.setTargetA(0);
  playpauseglow.gotoTarget();

  playpauseleave=1;  
}

prev.onEnterArea() {
  prevglow.setTargetA(255);
  prevglow.gotoTarget();

  prevleave=0;
}

prev.onLeaveArea() {
  prevglow.setTargetA(0);
  prevglow.gotoTarget();

  prevleave=1;  
}

next.onEnterArea() {
  nextglow.setTargetA(255);
  nextglow.gotoTarget();

  nextleave=0;
}

next.onLeaveArea() {
  nextglow.setTargetA(0);
  nextglow.gotoTarget();

  nextleave=1;  
}

stop.onEnterArea() {
  stopglow.setTargetA(255);
  stopglow.gotoTarget();

  stopleave=0;
}

stop.onLeaveArea() {
  stopglow.setTargetA(0);
  stopglow.gotoTarget();

  stopleave=1;  
}

open.onEnterArea() {
  openglow.setTargetA(255);
  openglow.gotoTarget();

  openleave=0;
}

open.onLeaveArea() {
  openglow.setTargetA(0);
  openglow.gotoTarget();

  openleave=1;  
}

playpauseglow.onTargetReached() {
  if (playpauseleave) {
    if (getAlpha() > 0) {
      playpauseglow.setTargetA(0);
      playpauseglow.gotoTarget();
    }
    return;
  }

  if (getAlpha() > 0) {
    playpauseglow.setTargetA(0);
    playpauseglow.gotoTarget();
  } else {
    playpauseglow.setTargetA(255);
    playpauseglow.gotoTarget();
  }
}

prevglow.onTargetReached() {
  if (prevleave) {
    if (getAlpha() > 0) {
      prevglow.setTargetA(0);
      prevglow.gotoTarget();
    }
    return;
  }

  if (getAlpha() > 0) {
    prevglow.setTargetA(0);
    prevglow.gotoTarget();
  } else {
    prevglow.setTargetA(255);
    prevglow.gotoTarget();
  }
}

nextglow.onTargetReached() {
  if (nextleave) {
    if (getAlpha() > 0) {
      nextglow.setTargetA(0);
      nextglow.gotoTarget();
    }
    return;
  }

  if (getAlpha() > 0) {
    nextglow.setTargetA(0);
    nextglow.gotoTarget();
  } else {
    nextglow.setTargetA(255);
    nextglow.gotoTarget();
  }
}

stopglow.onTargetReached() {
  if (stopleave) {
    if (getAlpha() > 0) {
      stopglow.setTargetA(0);
      stopglow.gotoTarget();
    }
    return;
  }

  if (getAlpha() > 0) {
    stopglow.setTargetA(0);
    stopglow.gotoTarget();
  } else {
    stopglow.setTargetA(255);
    stopglow.gotoTarget();
  }
}

openglow.onTargetReached() {
  if (openleave) {
    if (getAlpha() > 0) {
      openglow.setTargetA(0);
      openglow.gotoTarget();
    }
    return;
  }

  if (getAlpha() > 0) {
    openglow.setTargetA(0);
    openglow.gotoTarget();
  } else {
    openglow.setTargetA(255);
    openglow.gotoTarget();
  }
}
