/*************************************************************

  Anunaki - clock-digital.m
  by Leechbite

  - this script controls the digital-clock display.

*************************************************************/

#include <lib/std.mi>

Global group frameGroup;
Global text timehour, timemin, timesec, timecolon, timeampm;
Global timer clockrefresh;
Global boolean colonon;
Global int lasttime;

System.onScriptLoaded() {

  frameGroup = getScriptGroup();

  timehour = frameGroup.findObject("time.hour");
  timemin = frameGroup.findObject("time.minute");
  timesec = frameGroup.findObject("time.second");
  timecolon = frameGroup.findObject("time.colon");
  timeampm = frameGroup.findObject("time.ampm");

  clockrefresh = new timer;
  clockrefresh.setDelay(500);
  clockrefresh.onTimer();
}

system.onScriptUnloading() {
  frameGroup = NULL; // clears all events
  delete clockrefresh;
}

frameGroup.onSetVisible(boolean onoff) {
  if (onoff) {
    if (!clockrefresh.isRunning()) {
      clockrefresh.onTimer(); // freshes the clock display immediately
      clockrefresh.start();
    }
  } else {
    clockrefresh.stop(); // stop clock if not visible.
  }
}

clockrefresh.onTimer() {
  int timeint, diff;
  string di, timetxt, hour, min, sec, ampm;

  if (colonon) {
    timecolon.show();
    colonon=0;
  } else  {
    timecolon.hide();
    colonon=1;
  }

  timeint = getTimeOfDay();
  int diff = timeint-lasttime;
  if ((diff < 1000) && (diff > 0)) return; // last then one sec, dont bother updating.
  lasttime = timeint;

  ampm = "AM";
  if (timeint >= 43200000) {
    ampm = "PM";
    if (timeint >= 46800000)
      timeint = timeint -  43200000;
  } else if (timeint < 3600000) {
    timeint = timeint + 43200000;
  }

  timetxt = integerToLongTime(timeint);

  hour = getToken(timetxt, ":", 0);
  min = getToken(timetxt, ":", 1);
  sec = getToken(timetxt, ":", 2);

  timehour.setText(hour);
  timemin.setText(min);
  if (timesec!=NULL) timesec.setText(sec);
  timeampm.setText(ampm);
}
