// ******* Anunaki - Config.m **********

#include <lib/std.mi>
#include <lib/config.mi>
#include "attribs.m"

Global container configcont;
Global layout configLayout;

Global text fadeintext, fadeouttext, staytext;

Global tabsheet configTabs;

Global button updatebutton;

System.onScriptLoaded() {
	initAttribs();

	configcont = getContainer("Config");
	configlayout = configcont.getLayout("normal");

	fadeintext = configlayout.findObject("fadein.text");
	fadeouttext = configlayout.findObject("fadeout.text");
	staytext = configlayout.findObject("stay.text");

	notifier_fadeintime_attrib.onDataChanged();
	notifier_fadeouttime_attrib.onDataChanged();
	notifier_holdtime_attrib.onDataChanged();

	configTabs = configlayout.findObject("config.tabs");
	configTabs.setCurPage(getPrivateInt("Anunaki","configtabpage",0));

	group temp = configlayout.findObject("button.updatecheck");
	updatebutton = configlayout.findObject("button.updatecheck");
}

system.onScriptUnloading() {
	setPrivateInt("Anunaki","configtabpage",configTabs.getCurPage());
}

// *********** update scripts *************
updatebutton.onLeftClick() {
	browser updatebrowser = configlayout.findObject("browser.updatecheck");
	if (updatebrowser) {
		updatebrowser.setXMLParam("h","18");
		updatebrowser.refresh();
	}
}

configlayout.onSetVisible(boolean on) {
	if (on) return;
	browser updatebrowser = configlayout.findObject("browser.updatecheck");
	if (updatebrowser) {
		updatebrowser.setXMLParam("h","0");
	}
}

// *********** notifier scripts ***************

notifier_fadeintime_attrib.onDataChanged() {
	float sec = stringToInteger(getData())/1000;
	
	fadeintext.setText("Fade-in Time ("+floatToString(sec, 1)+" sec ):");
}

notifier_fadeouttime_attrib.onDataChanged() {
	float sec = stringToInteger(getData())/1000;
	
	fadeouttext.setText("Fade-out Time ("+floatToString(sec, 1)+" sec ):");
}

notifier_holdtime_attrib.onDataChanged() {
	float sec = stringToInteger(getData())/1000;
	
	staytext.setText("Hold Time ("+floatToString(sec, 1)+" sec ):");
}