/*************************************************************

  Anunaki - eqsliders.m
  by Leechbite

  - this script controls the eq sliders.

*************************************************************/

#include <lib/std.mi>

#define PREAMP 10

function changeslider(int band);

Global group frameGroup;
class Animatedlayer eqSlider;
Global eqSlider eqslider1,eqslider2,eqslider3,eqslider4,eqslider5,
		eqslider6,eqslider7,eqslider8,eqslider9,eqslider10,
		eqsliderPA;
Global guiobject eqcursortop, eqcursorbottom, eqcursorleft, eqcursorright;
Global int cursorlasttargetx=-1, cursorlasttargety=-1;
Global boolean eqchange;

Global timer eqcursortimer;

System.onScriptLoaded() {

  frameGroup = getScriptGroup();

  eqslider1 = frameGroup.findObject("eq.slider.1");
  eqslider2 = frameGroup.findObject("eq.slider.2");
  eqslider3 = frameGroup.findObject("eq.slider.3");
  eqslider4 = frameGroup.findObject("eq.slider.4");
  eqslider5 = frameGroup.findObject("eq.slider.5");
  eqslider6 = frameGroup.findObject("eq.slider.6");
  eqslider7 = frameGroup.findObject("eq.slider.7");
  eqslider8 = frameGroup.findObject("eq.slider.8");
  eqslider9 = frameGroup.findObject("eq.slider.9");
  eqslider10 = frameGroup.findObject("eq.slider.10");
  eqsliderPA = frameGroup.findObject("eq.slider.pre");

  eqcursortop = frameGroup.findObject("eq.slider.cursor.top");
  eqcursortop.setTargetSpeed(0.50);
  eqcursorbottom = frameGroup.findObject("eq.slider.cursor.bottom");
  eqcursorbottom.setTargetSpeed(0.50);
  eqcursorleft = frameGroup.findObject("eq.slider.cursor.left");
  eqcursorleft.setTargetSpeed(0.50);
  eqcursorright = frameGroup.findObject("eq.slider.cursor.right");
  eqcursorright.setTargetSpeed(0.50);

  eqcursortimer = new Timer;
  eqcursortimer.setDelay(500);

  int x;
  for (x=0; x<=10; x++)
    changeslider(x);
}

System.onScriptUnLoading() {
  delete eqcursortimer;
}

system.onEQBandChanged(int band, int newvalue) {
  changeslider(band);
}

system.onEQPreampChanged(int newvalue) {
  changeslider(PREAMP);
}

changeslider(int band) {
  eqslider eqband;
  string bandstr;
  int bandval;

  if (band==PREAMP) {
    bandstr = "pre";
    bandval = getEQPreamp();
  } else {
    bandstr = integertoString(band+1);
    bandval = getEQBand(band);
  }

  eqband = frameGroup.findObject("eq.slider."+bandstr);

  eqband.gotoframe(eqband.getlength()*(127+bandval)/255);
}

eqSlider.onLeftButtonDown(int x, int y) {
  eqchange = 1;
}

eqSlider.onMouseMove(int x, int y) {
  if (eqchange) {
    string bandstr = gettoken(getID(), ".", 2);

    if (bandstr=="pre") {
      setEQPreamp(127-254*(y-getTop())/getHeight());
    } else {
      setEQBand(stringtoInteger(bandstr)-1,127-254*(y-getTop())/getHeight());
    }
  }
  int targetx = getLeft()-getParent().getLeft();
  if (y < getTop()) y = gettop();
  if (y > (getTop()+getHeight())) y = getTop()+getHeight();
  int targety = y-getParent().getTop();

  if (cursorlasttargetx!=targetx) {
    eqcursortop.setTargetx(targetx);
    eqcursortop.gotoTarget();
    eqcursortop.setAlpha(160);
    eqcursortop.setTargetA(160);
    eqcursorbottom.setTargetx(targetx);
    eqcursorbottom.gotoTarget();
    eqcursorbottom.setAlpha(160);
    eqcursorbottom.setTargetA(160);
    cursorlasttargetx=targetx;

  }

  if (cursorlasttargety!=targety) {
    eqcursorleft.setXMLParam("y", integerTostring(targety));
    eqcursorright.setXMLParam("y", integerTostring(targety));
    eqcursorleft.setAlpha(160);
    eqcursorright.setAlpha(160);
    cursorlasttargety=targety;
  }
}

eqSlider.onLeftButtonUp(int x, int y) {
  if (eqchange) {
    string bandstr = gettoken(getID(), ".", 2);

    if (bandstr=="pre") {
      setEQPreamp(127-254*(y-getTop())/getHeight());
    } else {
      setEQBand(stringtoInteger(bandstr)-1,127-254*(y-getTop())/getHeight());
    }
  }
  eqchange = 0;
}

eqSlider.onEnterArea() {
  eqcursortimer.stop();
}

eqSlider.onLeaveArea() {
  eqcursortimer.start();
}

eqcursortimer.onTimer() {
  stop();

  eqcursortop.setTargetA(0);
  eqcursorbottom.setTargetA(0);
  eqcursorleft.setTargetA(0);
  eqcursorright.setTargetA(0);

  eqcursortop.gotoTarget();
  eqcursorbottom.gotoTarget();
  eqcursorleft.gotoTarget();
  eqcursorright.gotoTarget();
}