/*
	Anunaki - fs-wheel.m
	by Leechbite

	- fullscreen wheel control (vol, bal, bass & treble) control scripts
*/

fswheelLoad() {
  fsWheelVol = mainfs.findObject("wheel.vol");
  fsWheelBal = mainfs.findObject("wheel.bal");
  fsWheelBass = mainfs.findObject("wheel.bass");
  fsWheelTreb = mainfs.findObject("wheel.treb");

  fsWheelVolgroove = mainfs.findObject("wheel.vol.groove");
  fsWheelBalgroove = mainfs.findObject("wheel.bal.groove");
  fsWheelBassgroove = mainfs.findObject("wheel.bass.groove");
  fsWheelTrebgroove = mainfs.findObject("wheel.treb.groove");

  fswheeladjust = 0;

  fswheelmapbig = new map;
  fswheelmapbig.loadmap("fs.wheel.map.big");

  fsvolumeTrap = mainfs.findObject("volume.base");
  fsvolumeLed = mainfs.findObject("volume.led");

  fsvolumeMap = new map;
  fsvolumeMap.loadmap("fs.volume.map");
}

fswheelUnLoad() {
  delete fswheelmapbig;
  delete fsvolumeMap;
}

fsvolumetrap.onLeftButtonDown(int x, int y) {
  voladjust = 1;

  int rx = x-getLeft();
  int ry = y-getTop();

  int newval = fsVolumeMap.getValue(rx, ry);

  setVolume(newval);
}

fsvolumetrap.onMouseMove(int x, int y) {
  if (voladjust) {

    int rx = x-getLeft();
    int ry = y-getTop();
    if (rx < 0) rx = 0;
    if (ry < 0) ry = 0;
    if (rx > getWidth()) rx = getWidth();
    if (ry > getHeight()) ry = getHeight();
    int newval = fsVolumeMap.getValue(rx, ry);

    setVolume(newval);
  }
}

fsvolumetrap.onLeftButtonUp(int x, int y) {
  voladjust = 0;
}

fsWheel.onLeftButtonDown(int x, int y) {
  fswheeladjust = 1;

  int rx = (x-getLeft())*fswheelmapbig.getWidth()/getWidth();
  int ry = (y-getTop())*fswheelmapbig.getHeight()/getHeight();

  lastwheelval = fswheelmapbig.getValue(x-getLeft(), y-getTop());

  lastvol = getVolume();
  lastbal = balslider.getPosition();
  lastbass = getPrivateInt("Anunaki", "Last Bass", 127);
  lasttreble = getPrivateInt("Anunaki", "Last Treble", 127);

  if (strsearch(getID(),"treb") >= 0) fswheelmode = WHEEL_TREBLE;
  else if (strsearch(getID(),"bas") >= 0) fswheelmode = WHEEL_BASS;
  else if (strsearch(getID(),"bal") >= 0) fswheelmode = WHEEL_BALANCE;
  else fswheelmode = WHEEL_VOL;
}

fswheel.onLeftButtonUp(int x, int y) {
  if (fswheeladjust) {
    if (fswheelmode == WHEEL_SEEKER) {
      seekto(lastpos);
    }
    if (fswheelmode == WHEEL_BASS) {
      setBass(getPrivateInt("Anunaki", "Last Bass", 127));
    }
    if (fswheelmode == WHEEL_TREBLE) {
      setTreble(getPrivateInt("Anunaki", "Last Treble", 127));
    }
  }

  fswheeladjust = 0;
}

fswheel.onMouseMove(int x, int y) {
  if (fswheeladjust) {
    int rx = x-getLeft(); int ry = y-getTop();
    if ((rx<0) || (rx<0) || (rx>=getWidth()) || (ry>=getHeight()))
	return;

    rx = rx*fswheelmapbig.getWidth()/getWidth();
    ry = ry*fswheelmapbig.getHeight()/getHeight();

    int newwheelval = fswheelmapbig.getValue(rx, ry);
    int wheelangle =newwheelval-lastwheelval;
    int adjust = wheelangle;

    if (wheelangle<0) wheelangle=255+wheelangle;

    wheelangle = wheelangle * 360/255;

    int frame;

    if (fswheelmode == WHEEL_VOL) {
      frame = (wheelangle % 45)*fsWheelVolgroove.getLength()/44;
      fsWheelVolgroove.gotoFrame(frame);

      boolean resetvol = 0;
      if (adjust > 200) {
        adjust = -(255-adjust+lastwheelval);
        resetvol = 1;
      }
      if (adjust < -200) {
        adjust = (255-lastwheelval)+(255+adjust);
        resetvol = 1;
      }

      int newvol = lastvol + adjust;
      if (newvol < 0) newvol = 0;
      if (newvol > 255) newvol = 255;

      setVolume(newvol);
      if ((adjust>50) || (adjust<-50) || (resetvol)) {
	lastvol = newvol;
	lastwheelval = newwheelval;
      }
    } else if (fswheelmode == WHEEL_BALANCE) {
      frame = (wheelangle % 45)*fsWheelbalgroove.getLength()/44;
      fsWheelBalgroove.gotoFrame(frame);

      boolean resetbalance = 0;
      if (adjust > 200) {
        adjust = -(255-adjust+lastwheelval);
        resetbalance = 1;
      }
      if (adjust < -200) {
        adjust = (255-lastwheelval)+(255+adjust);
        resetbalance = 1;
      }

      int newbal = lastbal + adjust;
      if (newbal < 0) newbal = 0;
      if (newbal > 255) newbal =  255;
      if ((newbal > 120) && (newbal < 133)) newbal = 127; // snapping to center code

      balslider.setPosition(newbal);
      int pr;
      pr = newbal-127;
      pr = pr*100/127;

      if (pr>0) {
	setTempText("Bal Right: "+integertostring(pr)+"%");
      } else if (pr<0) {
	setTempText("Bal Left: "+integertostring(-pr)+"%");
      } else {
	setTempText("Bal Center");
      }

      if ((adjust>50) || (adjust<-50) || (resetbalance)) {
	lastbal = newbal;
	lastwheelval = newwheelval;
      }
    } else if (fswheelmode == WHEEL_BASS) {
      frame = (wheelangle % 45)*fsWheelBassgroove.getLength()/44;
      fsWheelBassgroove.gotoFrame(frame);

      boolean resetbass = 0;
      if (adjust > 200) {
        adjust = -(255-adjust+lastwheelval);
        resetbass = 1;
      }
      if (adjust < -200) {
        adjust = (255-lastwheelval)+(255+adjust);
        resetbass = 1;
      }

      int newbass = lastbass + adjust;
      if (newbass < 0) newbass = 0;
      if (newbass > 255) newbass =  255;

      int pr;
      pr = newbass-127;
      pr = pr*100/127;

      setTempText("Bass: "+integertostring(pr)+"%");
      setPrivateInt("Anunaki", "Last Bass", newbass);

      if ((adjust>50) || (adjust<-50) || (resetbass)) {
        lastbass = newbass;
	lastwheelval = newwheelval;
      }
    } else if (fswheelmode == WHEEL_TREBLE) {
      frame = (wheelangle % 45)*fsWheelTrebgroove.getLength()/44;
      fsWheelTrebgroove.gotoFrame(frame);

      boolean resettreble = 0;
      if (adjust > 200) {
        adjust = -(255-adjust+lastwheelval);
        resettreble = 1;
      }
      if (adjust < -200) {
        adjust = (255-lastwheelval)+(255+adjust);
        resettreble = 1;
      }

      int newtreble = lasttreble + adjust;
      if (newtreble < 0) newtreble = 0;
      if (newtreble > 255) newtreble =  255;

      int pr;
      pr = newtreble-127;
      pr = pr*100/127;

      setTempText("Treble: "+integertostring(pr)+"%");
      setPrivateInt("Anunaki", "Last Treble", newtreble);

      if ((adjust>50) || (adjust<-50) || (resettreble)) {
        lasttreble = newtreble;
	lastwheelval = newwheelval;
      }
    }
  }
}
