/*
	Anunaki - fs.m
	by Leechbite

	- fullscreen elements control scripts
*/

fsLoad() {
  fsbase1group = mainfs.findObject("fs.base1");
  fsbase1groove = mainfs.findObject("fs.base1.groove");

  fscbuttonsGroup = mainfs.findObject("fs.cbuttons");

  fsbase2group = mainfs.findObject("fs.base2");
  fsbase2groove = mainfs.findObject("fs.base2.groove");
  fsbase2ventleft = mainfs.findObject("fs.base2.vent.left");
  fsbase2ventright = mainfs.findObject("fs.base2.vent.right");

  fsPL = mainfs.findObject("fs.pl");
  fsVis = mainfs.findObject("fs.vis");
  fsML = mainfs.findObject("fs.ml");

  whPL = mainfs.findObject("fs.wh.pl");
  whML = mainfs.findObject("fs.wh.ml");
  whAVS = mainfs.findObject("fs.wh.avs");
  whVID = mainfs.findObject("fs.wh.vid");
  fsBarOsc = mainfs.findObject("fs.vis.barosc");

  fsPLresizer = fsPL.getObject("fs.pl.resizer");
  fsPLresizerTimer = new timer;
  fsPLresizerTimer.setDelay(200);

  fsResButton = mainfs.findObject("fs.pbutton.res");

  fsLocalOpen = FALSE;
  fsLocalClose = FALSE;

  group temp = mainfs.findObject("customres.ok");
  customresOk = temp.getObject("wasabi.button");
  temp = mainfs.findObject("customres.cancel");
  customresCancel = temp.getObject("wasabi.button");

  fsEq = mainfs.findObject("fs.eq");
  fsClock = mainfs.findObject("fs.clock");
  fsCT = mainfs.findObject("fs.ct");
  callrefresh = new timer;
  callrefresh.setDelay(1);

  callbackTimershow = new timer;
  callbackTimershow.setDelay(1);
  callbackTimer2 = new timer;
  callbackTimer2.setDelay(100);
  PSOVCTimer = new Timer;
  PSOVCTimer.setDelay(1000);

  callbackTimerResizer = new timer;
  callbackTimerResizer.setDelay(100);

  resizer = mainfs.findObject("resizer");

  // toggle buttons taken from the stick mode.
  togglePL = mainstick.findObject("PL");
  toggleML = mainstick.findObject("ML");
  toggleVID = mainnormal.findObject("VID");
  toggleAVS = mainstick.findObject("AVS");

  callbackTimerLoad = new timer;
  callbackTimerLoad.setDelay(1);
  callbackTimerLoad.start();
}

// ** on start-up the main container doesnt know yet what's the current layout so timer is needed
// ** to wait for it to know.
callbackTimerLoad.onTimer() {
  stop();

  if (maincont.getCurLayout() == mainfs) {
    firstopen = 1;

    setTempText("fs");
    fsonBeforeSwitchToLayout(mainfs, mainfs);
    fsonSwitchToLayout(mainfs);

    firstopen = 0;
  }
}

fsUnLoad() {
  delete callbackTimershow;
  delete callbackTimer2;
  delete callbackTimerResizer;
  delete PSOVCTimer;
  delete fsPLresizerTimer;
  delete callrefresh;
  delete callbackTimerLoad;
  return;
}

fsonBeforeSwitchToLayout(Layout oldl, layout lay) {
  oldlayout = oldl;

  if (lay != mainfs) {

    fsLocalOpen = 1;
    whPL.hide();
    whML.hide();
    fsPL.hide();
    fsML.hide();
    whAVS.hide();
    whVID.hide();
    fsVis.hide();
    fsLocalOpen = 0;

    return;
  } else {
    // checks for basic components and closes them if their open
    if (isNamedWindowVisible(VID_GUID)) hideNamedWindow(VID_GUID);
    if (isNamedWindowVisible(VIS_GUID)) hideNamedWindow(VIS_GUID);
    if (isNamedWindowVisible(ML_GUID)) hideNamedWindow(ML_GUID);
    if (isNamedWindowVisible(PL_GUID)) hideNamedWindow(PL_GUID);
    return;
  }
}

fsonSwitchToLayout(layout lay) {
  if (lay == mainfs) {

    if (!firstopen) setPrivateInt("Anunaki","LastAOTfs", aot.getActivated());
    if (aot.getActivated() == 1) aot.leftClick();

    party_PL_attrib.onDataChanged();
    party_ML_attrib.onDataChanged();
    party_Vis_attrib.onDataChanged();
    party_AVS_attrib.onDataChanged();
    party_VID_attrib.onDataChanged();
    party_bars_attrib.onDataChanged();
    party_osc_attrib.onDataChanged();
    party_off_attrib.onDataChanged();
    group customresBox = mainfs.findObject("fs.customres");
    customresBox.hide();

    if (!firstopen) setPrivateString("Anunaki", "Last EQ Status", eq_visible_attrib.getData());
    eqattribchange = 1;
    eq_visible_attrib.setData(party_eq_attrib.getData());
    eqattribchange = 0;

    refreshEQCTCl();

    setfsResolution(RES_CURRENT);
  } else {

    int lastaotmode = getPrivateInt("Anunaki","LastAOTfs", -1);
    if ((lastaotmode != aot.getActivated()) && (lastaotmode!=-1)) aot.leftClick();

    if (oldlayout == mainfs) {
      eq_visible_attrib.setData(getPrivateString("Anunaki", "Last EQ Status", eq_visible_attrib.getData()));

      if (togglePL.getActivated() != 0) togglePL.leftClick();
      if (toggleML.getActivated() != 0) toggleML.leftClick();
      if (toggleAVS.getActivated() != 0) toggleAVS.leftClick();
      if (toggleVID.getActivated() != 0) toggleVID.leftClick();

      return;
    }
  }
}

aot.onActivate(int on) {
  if (!mainfs.isvisible()) setPrivateInt("Anunaki","LastAOTfs", on);
}

resizefsWindow(int x, int y, int w, int h) {
  float fw  = w, fh = h;
  w = fw / mainfs.getScale();
  h = fh / mainfs.getScale();

  if (x < 0) x = 0;
  if (x > (mainfs.getLeft()+mainfs.getWidth() - 200)) x = mainfs.getLeft()+mainfs.getWidth() - 200;
  if (y < 0) y = 0;
  if (y > (mainfs.getLeft()+mainfs.getWidth() - 200)) x = mainfs.getLeft()+mainfs.getWidth() - 200;
  if (w < 750) w = 750;
  if (w > 1600) w = 1600;
  if (h < 650) h = 650;
  if (h > 1200) h = 1200;

  mainfs.setXMLParam("maximum_h",integerToString(h));
  mainfs.setXMLParam("maximum_w",integerToString(w));
  mainfs.setXMLParam("minimum_h",integerToString(h));
  mainfs.setXMLParam("minimum_w",integerToString(w));

  mainfs.resize(x, y, w, h);
}

mainfs.onScale(double newscale) {
  resizefsWindow(mainfs.getLeft(),mainfs.getTop(),mainfs.getWidth(),mainfs.getHeight());
}

mainfs.onResize(int x, int y, int w, int h) {
  mainfs.setXMLParam("maximum_h",integerToString(h));
  mainfs.setXMLParam("maximum_w",integerToString(w));
  mainfs.setXMLParam("minimum_h",integerToString(h));
  mainfs.setXMLParam("minimum_w",integerToString(w));

  fsPLMaxWidth = w - 600;
  resizePLWidth(getPrivateInt("Anunaki", "fsPLWidth", 270));
  refreshEQCTCl();
}

resizer.onEnterArea() {
  mainfs.setXMLParam("maximum_h","5000");
  mainfs.setXMLParam("maximum_w","5000");
  mainfs.setXMLParam("minimum_h","600");
  mainfs.setXMLParam("minimum_w","800");
}

resizer.onLeaveArea() {
  callbackTimerResizer.start();
}

callbackTimerResizer.onTimer() {
  stop();

  int w = mainfs.getWidth();
  int h = mainfs.getHeight();

  mainfs.setXMLParam("maximum_h",integerToString(h));
  mainfs.setXMLParam("maximum_w",integerToString(w));
  mainfs.setXMLParam("minimum_h",integerToString(h));
  mainfs.setXMLParam("minimum_w",integerToString(w));

}

fsbase1group.onResize(int x, int y, int w, int h) {
  centerObject(fsbase1groove, 1, 0);
}

fsbase2group.onResize(int x, int y, int w, int h) {
  centerObject(fscbuttonsGroup, 1, 0);
  centerObject(fsbase2groove, 1, 0);

  fsbase2ventleft.setXMLParam("w", integerToString(fscbuttonsGroup.getLeft()-40));
  fsbase2ventright.setXMLParam("x", integerToString(fscbuttonsGroup.getLeft()+fscbuttonsGroup.getWidth()+20));
  fsbase2ventright.setXMLParam("w", integerToString(-fscbuttonsGroup.getLeft()-fscbuttonsGroup.getWidth()-40));
}

// centers guiobjects depending on parent group/layout
centerObject(guiObject obj, boolean centx, boolean centy) {

  guiObject parentobj = obj.getParent();

  int x;
  if (centx) 
    x = (parentobj.getWidth() - obj.getWidth())/2;
  else
    x = obj.getGuiX();
  if (centy) 
    y = (parentobj.getHeight() - obj.getHeight())/2;
  else
    y = obj.getGuiY();

  obj.setXMLParam("x", integerToString(x));
  obj.setXMLParam("y", integerToString(y));

}

fsBarOsc.onResize(int x, int y, int w, int h) {
  vis visobj = fsBarOsc.getObject("vis");
  layer visgrid = fsBarOsc.getObject("vis.grid");

  centerObject(visobj, 0, 1);

  visgrid.setXMLParam("y",visobj.getXMLParam("y"));

  layer fsanunaki = fsVIS.findObject("anunaki");
  fsanunaki.setXMLParam("x" , integerToString((w - fsanunaki.getWidth())/2));	// because of the stupid reflections,
  fsanunaki.setXMLParam("y" , integerToString((h - 57)/2));			// i wont use centerObject to center the title :)
}

// ******** PL resizing stuff *******

resizePLWidth(int w) {
  if (w < PL_MINWIDTH) w = PL_MINWIDTH;
  if (w > fsPLMaxWidth) w = fsPLMaxWidth;

  setPrivateInt("Anunaki", "fsPLWidth", w);
  //setTempText(integerToString(w));

  fsPL.setXMLParam("x" , integerToString(-w-40));
  fsPL.setXMLParam("w" , integerToString(w));

  fsVIS.setXMLParam("w" , integerToString(-fsVIS.getLeft()-w-40));
  fsML.setXMLParam("w" , integerToString(-fsML.getLeft()-w-40));

}

fsPLresizer.onLeftButtonDown(int x, int y) {
  PLresizerLBDown = 1;

  fsPLresizerX = x;
  orgPLWid = getPrivateInt("Anunaki", "fsPLWidth", 270);
  newplwid = orgPLWid;
  setXMLPAram("resize","");  	// *** for some reasons, layers with resize attrib ON messes up
				// onLeftButtonDown and onLeftButton up.
  fsPLresizerTimer.start();
}

fsPLresizer.onLeftButtonUp(int x, int y) {
  PLresizerLBDown = 0;

  fsPLresizerTimer.stop();

  int neww = orgPLWid + fsPLresizerX - x;
  resizePLWidth(neww);

  setXMLPAram("resize","right"); // *** back to resize="right"

}

fsPLresizer.onMouseMove(int x, int y) {
  if (!PLresizerLBDown) return;

  newplwid = orgPLWid + fsPLresizerX - x;
}

fsPLresizerTimer.onTimer() {
  if (!PLresizerLBDown) return;

  resizePLWidth(newplwid);
}

fsPL.onResize(int x, int y, int w, int h) {
  layer fsPLgroove = fsPL.getObject("fs.pl.resizer.groove");

  centerObject(fsPLgroove, 0, 1);
}


// ******* Resolution Menu *****
fsResButton.onLeftClick() {
  popUpMenu resMenu = new popUpMenu;

  int currMode = getPrivateInt("Anunaki","Screen Resolution", 1);

  resMenu.addCommand("- Screen Resolution -", -1, 0, 1);
  resMenu.addSeparator();
  resMenu.addCommand(" Auto Detect", RES_AUTO, currMode == RES_AUTO, 0);
  resMenu.addCommand(" Viewport", RES_VIEWP, currMode == RES_VIEWP, 0);
  resMenu.addCommand(" Custom", RES_CUSTOM, currMode == RES_CUSTOM, 0);
  resMenu.addSeparator();
  resMenu.addCommand(" 800 x 600", 101, currMode == 101, 0);
  resMenu.addCommand(" 1024 x 768", 102, currMode == 102, 0);
  resMenu.addCommand(" 1152 x 864", 103, currMode == 103, 0);
  resMenu.addCommand(" 1152 x 870", 104, currMode == 104, 0);
  resMenu.addCommand(" 1280 x 720", 105, currMode == 105, 0);
  resMenu.addCommand(" 1280 x 768", 106, currMode == 106, 0);
  resMenu.addCommand(" 1280 x 960", 107, currMode == 107, 0);
  resMenu.addCommand(" 1280 x 1024", 108, currMode == 108, 0);
  resMenu.addCommand(" 1600 x 1200", 109, currMode == 109, 0);

  int res = resMenu.popAtMouse();
  delete resMenu;

  if (res < 0) return;

  setfsResolution(res);

  complete;
}

setfsResolution(int mode) {
  if (mode == RES_CURRENT) {
    mode = getPrivateInt("Anunaki","Screen Resolution", 1);
    if (mode == RES_CUSTOM) { setToCustomRes(); return; }
  } else if (mode != RES_CUSTOM)
    setPrivateInt("Anunaki","Screen Resolution", mode);

  if (mode == RES_AUTO) {
    resizefsWindow(0, 0, getAutoResWidth(), getAutoResHeight());
  } else if (mode == RES_VIEWP) {
    resizefsWindow(getViewPortLeft(), getViewPortTop(), getViewPortWidth(), getViewPortHeight());
  } else if (mode == RES_CUSTOM) {
    setCustomRes();
  } else if (mode == 101) {
    resizefsWindow(0, 0, 800, 600);
  } else if (mode == 102) {
    resizefsWindow(0, 0, 1024, 768);
  } else if (mode == 103) {
    resizefsWindow(0, 0, 1152, 864);
  } else if (mode == 104) {
    resizefsWindow(0, 0, 1152, 870);
  } else if (mode == 105) {
    resizefsWindow(0, 0, 1280, 720);
  } else if (mode == 106) {
    resizefsWindow(0, 0, 1280, 768);
  } else if (mode == 107) {
    resizefsWindow(0, 0, 1280, 960);
  } else if (mode == 108) {
    resizefsWindow(0, 0, 1280, 1024);
  } else if (mode == 109) {
    resizefsWindow(0, 0, 1600, 1200);
  }

}

getAutoResWidth() {
  int vpx = getViewPortLeft();
  int vpw = getViewPortWidth();

  int totw = vpx + vpw;

  if (totw <= 800) totw = 800;
  else if (totw <= 1024) totw = 1024;
  else if (totw <= 1152) totw = 1152;
  else if (totw <= 1280) totw = 1280;
  else if (totw <= 1600) totw = 1600;

  return totw;
}

getAutoResHeight() {
  int vpy = getViewPortTop();
  int vph = getViewPortHeight();

  int toth = vpy + vph;

  if (toth <= 600) toth = 600;
  else if (toth <= 720) toth = 720;
  else if (toth <= 768) toth = 768;
  else if (toth <= 864) toth = 864;
  else if (toth <= 870) toth = 870;
  else if (toth <= 960) toth = 960;
  else if (toth <= 1024) toth = 1024;
  else if (toth <= 1200) toth = 1200;

  return toth;
}

setCustomRes() {
  group customresBox = mainfs.findObject("fs.customres");
  edit inputx = customresBox.getObject("edit.customx");
  edit inputy = customresBox.getObject("edit.customy");
  edit inputw = customresBox.getObject("edit.customw");
  edit inputh = customresBox.getObject("edit.customh");

  inputx.setText(integerToString(mainfs.getLeft()));
  inputy.setText(integerToString(mainfs.getTop()));
  inputw.setText(integerToString(mainfs.getWidth()));
  inputh.setText(integerToString(mainfs.getHeight()));

  customresBox.show();
}

customresOk.onLeftClick() {
  group customresBox = mainfs.findObject("fs.customres");
  edit inputx = customresBox.getObject("edit.customx");
  edit inputy = customresBox.getObject("edit.customy");
  edit inputw = customresBox.getObject("edit.customw");
  edit inputh = customresBox.getObject("edit.customh");

  customresBox.hide();

  int x = stringToInteger(inputx.getText());
  int y = stringToInteger(inputy.getText());
  int w = stringToInteger(inputw.getText());
  int h = stringToInteger(inputh.getText());
  
  if (x < 0) x = 0;
  if (x > (mainfs.getLeft()+mainfs.getWidth() - 200)) x = mainfs.getLeft()+mainfs.getWidth() - 200;
  if (y < 0) y = 0;
  if (y > (mainfs.getLeft()+mainfs.getWidth() - 200)) x = mainfs.getLeft()+mainfs.getWidth() - 200;
  if (w < 750) w = 750;
  if (w > 1600) w = 1600;
  if (h < 650) h = 650;
  if (h > 1200) h = 1200;

  setPrivateInt("Anunaki","Screen Resolution", RES_CUSTOM);
  setPrivateInt("Anunaki","Custom x", x);
  setPrivateInt("Anunaki","Custom y", y);
  setPrivateInt("Anunaki","Custom w", w);
  setPrivateInt("Anunaki","Custom h", h);
  setToCustomRes();

}

customresCancel.onLeftClick() {
  group customresBox = mainfs.findObject("fs.customres");

  customresBox.hide();
}

setToCustomRes() {
  group customresBox = mainfs.findObject("fs.customres");
  edit inputx = customresBox.getObject("edit.customx");
  edit inputy = customresBox.getObject("edit.customy");
  edit inputw = customresBox.getObject("edit.customw");
  edit inputh = customresBox.getObject("edit.customh");

  resizefsWindow(getPrivateInt("Anunaki","Custom x", mainfs.getLeft()),
	   getPrivateInt("Anunaki","Custom y", mainfs.getTop()),
	   getPrivateInt("Anunaki","Custom w", mainfs.getWidth()),
	   getPrivateInt("Anunaki","Custom h", mainfs.getHeight()));
}

party_PL_attrib.onDataChanged() {
  fsLocalOpen = 1;
  callbacktimer2.start();

  if (getData()=="0") {

    fsPL.hide();
    whPL.hide();

    fsVIS.setXMLParam("w" , integerToString(-fsVIS.getLeft()-40));
    fsML.setXMLParam("w" , integerToString(-fsVIS.getLeft()-40));

  } else {

    fsPL.show();
    whPL.show();
    resizePLWidth(getPrivateInt("Anunaki", "fsPLWidth", 270));

  }
}

party_ML_attrib.onDataChanged() {
  fsLocalOpen = 1;
  callbacktimer2.start();

  if (getData()=="0") {

    fsML.hide();
    whML.hide();

  } else {

    fsML.show();
    whML.show();

  }
}

party_vis_attrib.onDataChanged() {
  fsLocalOpen = 1;
  callbacktimer2.start();

  if (getData()=="0") {
   whAVS.hide();
   whVID.hide();
   fsVIS.hide();

  } else {

    fsVIS.show();
    if ((party_AVS_attrib.getData()!="1") &&
	(party_VID_attrib.getData()!="1") &&
	(party_bars_attrib.getData()!="1") && 
	(party_osc_attrib.getData()!="1") && 
	(party_off_attrib.getData()!="1")) {
      string lastmode = getPrivateString("Anunaki","Last Vis","");
      if (lastmode == "AVS") party_AVS_attrib.setData("1");
      if (lastmode == "VID") party_VID_attrib.setData("1");
      if (lastmode == "bars") party_bars_attrib.setData("1");
      if (lastmode == "osc") party_osc_attrib.setData("1");

    }
  }
}

party_AVS_attrib.onDataChanged() {
  fsLocalAVS = 1;
  callbacktimer2.start();

  guiObject controls = fsVIS.getObject("fs.vis.avs.buttons");

  if (getData()=="0") {

    controls.hide();
    whAVS.hide();

  } else {
    text titlebar = fsVIS.getObject("titlebar");
    titlebar.setText("VISUALIZATION");
    controls.show();
    whAVS.show();
    setPrivateString("Anunaki","Last Vis","AVS");

  }
}

party_VID_attrib.onDataChanged() {
  fsLocalVID = 1;
  callbacktimer2.start();

  guiObject controls = fsVIS.getObject("fs.vis.vid.buttons");

  if (getData()=="0") {

    controls.hide();
    disablePSOVC();
    whVID.hide();

  } else {

    text titlebar = fsVIS.getObject("titlebar");
    titlebar.setText("VIDEO");
    controls.show();
    whVID.show();
    setPrivateString("Anunaki","Last Vis","VID");

  }
}

party_bars_attrib.onDataChanged() {

  if (getData()=="0") {

    if (party_osc_attrib.getData()=="0") fsBarOsc.hide();

  } else {

    fsBarOsc.show();
    vis temp = fsBarOsc.getObject("vis");
    temp.setMode(1);
    text titlebar = fsVIS.getObject("titlebar");
    titlebar.setText("SPECTRUM ANALYZER");
    setPrivateString("Anunaki","Last Vis","bars");

  }

}

party_osc_attrib.onDataChanged() {
  if (getData()=="0") {

    if (party_bars_attrib.getData()=="0") fsBarOsc.hide();

  } else {

    fsBarOsc.show();
    vis temp = fsBarOsc.getObject("vis");
    temp.setMode(2);
    text titlebar = fsVIS.getObject("titlebar");
    titlebar.setText("OSCILLOSCOPE");
    setPrivateString("Anunaki","Last Vis","osc");

  }
}

party_OFF_attrib.onDataChanged() {
  fsLocalOpen = 1;
  callbacktimer2.start();

  layer fsanunaki = fsVIS.findObject("anunaki");

  if (getData()=="1") {

    whVID.hide();
    whAVS.hide();
    text titlebar = fsVIS.getObject("titlebar");
    titlebar.setText("NO VISUALS");
    setPrivateString("Anunaki","Last Vis","off");

    fsanunaki.setTargetA(255);
    fsanunaki.setTargetX(fsanunaki.getGuiX());
    fsanunaki.setTargetY(fsanunaki.getGuiY());
    fsanunaki.setTargetSpeed(1);
    fsanunaki.gotoTarget();
  } else {
    fsanunaki.cancelTarget();
    fsanunaki.setAlpha(0);
  }
}

callbacktimer2.onTimer() {
  stop();
  fsLocalOpen = 0;
  fsLocalAVS = 0;
  fsLocalVID = 0;
}

// components controls
system.onGetCancelComponent(String guid, boolean goingvisible) {
  //messageBox(strlower(guid),"Test",1,"confirm");
  if (mainfs.isVisible()) {
    if (fsLocalOpen)  return FALSE; 
    if (fsLocalClose) return FALSE;

    if (guid==VID_GUID) {
      if (fsLocalVID) return FALSE;

      if (goingvisible) {
	showComponent(VID_ID);
        return TRUE;
      } else {
	party_VID_attrib.setData("0");
	if (party_AVS_attrib.getData()=="0")
	  party_OFF_attrib.setData("0");
        return FALSE;
      }
    } else if (guid==VIS_GUID) {
      if (fsLocalAVS) return FALSE;
      if (goingvisible) {
	showComponent(VIS_ID);
        return TRUE;
      } else {
	party_AVS_attrib.setData("0");
	if (party_VID_attrib.getData()=="0")
	  party_OFF_attrib.setData("0");
        return FALSE;
      }
    } else if (guid==ML_GUID) {
      if (goingvisible) {
	showComponent(ML_ID);
        return TRUE;
      } else {
	party_ML_attrib.setData("0");
        return FALSE;
      }
    } else if (guid==PL_GUID) {

      if (goingvisible) {
	showComponent(PL_ID);
        return TRUE;
      } else {
	party_PL_attrib.setData("0");
        return FALSE;
      }
    }
  }
  return FALSE;
}

showComponent(int compID) {
  showcompID = compID;
  //if (callbacktimershow.isRunning()) callbacktimershow.stop();
  callbacktimershow.start();
}


callbacktimershow.onTimer() {
  stop();

  if (showcompID == VID_ID) {
    party_VID_attrib.setData("1");

  } else if (showcompID == VIS_ID) {

    party_AVS_attrib.setData("1");

  } else if (showcompID == ML_ID) {

    party_ML_attrib.setData("1");

  } else if (showcompID == PL_ID) {

    party_PL_attrib.setData("1");

  }

  showcompID = -1;
}

PSOVCTimer.onTimer() {
    enablePSOVC();
}

disablePSOVC() {
    ConfigItem item = Config.getItem(SKINTWEAKS_CFGPAGE);
    if (item) {
        ConfigAttribute attr = item.getAttribute("Prevent video playback Stop on video window Close");
        if (attr) attr.setData("1");
    }
    PSOVCTimer.start();
}

enablePSOVC() {
    PSOVCTimer.stop();
    ConfigItem item = Config.getItem(SKINTWEAKS_CFGPAGE);
    if (item) {
        ConfigAttribute attr = item.getAttribute("Prevent video playback Stop on video window Close");
        if (attr) attr.setData("0");
    }
}

// ******** EQ, ColorThemes & Clock scripts
party_eq_attrib.onDataChanged() {
  if (getData()=="1")
    setPrivateInt("Anunaki", "fs_EQCTCl_Priority", PRIO_EQ);

  if (mainfs.isVisible()) {
    if (!eqattribchange) {
      eqattribchange = 1;
      eq_visible_attrib.setData(getData());
      eqattribchange = 0;
    }
  }

  callrefresh.start();
}

party_analclock_attrib.onDataChanged() {
  if (getData()=="1")
    setPrivateInt("Anunaki", "fs_EQCTCl_Priority", PRIO_CLOCK);
  callrefresh.start();
}

party_digitclock_attrib.onDataChanged() {
  if (getData()=="1")
    setPrivateInt("Anunaki", "fs_EQCTCl_Priority", PRIO_CLOCK);
  callrefresh.start();
}

party_ct_attrib.onDataChanged() {
  if (getData()=="1")
    setPrivateInt("Anunaki", "fs_EQCTCl_Priority", PRIO_CT);

  callrefresh.start();
}

callrefresh.onTimer() {
  stop();

  refreshEQCTCl();
}

refreshEQCTCl() {
  int priority = getPrivateInt("Anunaki", "fs_EQCTCl_Priority", PRIO_EQ);
  int y, h, remh;
  boolean alloff = TRUE;

  y = 70;
  if ((party_analclock_attrib.getData()=="1") || (party_digitclock_attrib.getData()=="1")) y = 188;
  if (party_eq_attrib.getData()=="1") 
    h = -502-y;
  else
    h = -327-y;

  remh = mainfs.getHeight() + h;

  if (party_eq_attrib.getData() == "1") {
    alloff = FALSE;

    if (remh < 0) { // not enough space? close some...

      if (priority == PRIO_EQ) {  // if EQ is priority, close ct or clock.

	if ((party_analclock_attrib.getData()=="1") || (party_digitclock_attrib.getData()=="1")) {
	  party_analclock_attrib.setData("0");
	  party_digitclock_attrib.setData("0");
	} else if (party_ct_attrib.getData()=="1")
	  party_ct_attrib.setData("0");
      } else {
	party_eq_attrib.setData("0"); // not priority, close ct
      }

    }

    fsEQ.show();

  } else {
    fsEQ.hide();
  }

  guiobject clockcontent = fsClock.getObject("fs.clock.content");
  if (party_analclock_attrib.getData()=="1") {

    clockcontent.setXMLParam("groupid","fs.clock.analog");
    fsClock.show();

  } else if (party_digitclock_attrib.getData()=="1") {

    clockcontent.setXMLParam("groupid","fs.clock.digital");
    fsClock.show();

  } else {
    fsClock.hide();
  }

  if ((party_analclock_attrib.getData()=="1") || (party_digitclock_attrib.getData()=="1")) {
    alloff = FALSE;

    if (party_ct_attrib.getData()=="0") {
      int centery = remh/2;
      fsClock.setXMLParam("y", integerToString(70 + centery));
    } else {
      fsClock.setXMLParam("y", "70");
    }
  }

  if (party_ct_attrib.getData() == "1") {
    alloff = FALSE;

    if (remh < 100) { // not enough space? close some...

      if (priority == PRIO_CT) {  // if CT is priority, close clock or eq.
	if ((party_analclock_attrib.getData()=="1") || (party_digitclock_attrib.getData()=="1")) {
	  party_analclock_attrib.setData("0");
	  party_digitclock_attrib.setData("0");
	} else if (party_eq_attrib.getData()=="1")
	  party_eq_attrib.setData("0");
      } else {
	party_ct_attrib.setData("0"); // not priority, close ct
      }

    } else {

      fsCT.setXMLParam("y", integerToString(y));
      fsCT.setXMLParam("h", integerToString(h));

    }
    fsCT.show();

  } else {
    fsCT.hide();
  }

  if (alloff) {
    fsVIS.setXMLParam("x" , "45");
    fsML.setXMLParam("x" , "45");
  } else {
    fsVIS.setXMLParam("x" , "260");
    fsML.setXMLParam("x" , "260");
  }
  
  party_PL_attrib.onDataChanged();
}
