/*************************************************************

  Anunaki - fullscreen.m
  by Leechbite

  - this script controls fullscreen controls of media lib & pl

*************************************************************/

#include <lib/std.mi>

Global layout parentLayout;
Global group frameGroup;
Global button buttonFullScr;
Global layer buttonlabel;
Global guiObject resizeDisabler;

Global boolean onFullScr;
Global string contName, orglabel, orgToolTip;

System.onScriptLoaded() {

  frameGroup = getScriptGroup();
  parentLayout = frameGroup.getParentLayout();

  buttonFullScr = frameGroup.getObject("fullscr");
  buttonLabel = frameGroup.getObject("label");
  orgToolTip = buttonFullScr.getXMLParam("toolTip");
  orglabel = buttonLabel.getXMLParam("image");

  resizeDisabler = frameGroup.findObject("window.resize.disabler");

  text titleBar = frameGroup.findObject("titlebar");
  contName = titleBar.getText();
  
  onFullScr = getPrivateInt("Anunaki",contName+"_onFullScr", 0);
  if (onFullscr) {
    parentLayout.resize(getViewPortLeft(),getViewPortTop(),getViewPortWidth(),getViewPortHeight());
    resizeDisabler.setXMLParam("ghost","0");
    resizeDisabler.setXMLParam("move","0");
  }
}

system.onScriptUnloading() {
  buttonFullScr = NULL;
  buttonLabel = NULL;
}

buttonFullscr.onLeftClick() {
  onFullScr = !onFullScr;
  setPrivateInt("Anunaki",contName+"_onFullScr", onFullScr);

  if (onFullScr) {
    setPrivateInt("Anunaki",contName+"_lastX", parentLayout.getLeft());
    setPrivateInt("Anunaki",contName+"_lastY", parentLayout.getTop());
    setPrivateInt("Anunaki",contName+"_lastW", parentLayout.getWidth());
    setPrivateInt("Anunaki",contName+"_lastH", parentLayout.getHeight());

    parentLayout.resize(getViewPortLeft(),getViewPortTop(),getViewPortWidth(),getViewPortHeight());
    resizeDisabler.setXMLParam("ghost","0");
    resizeDisabler.setXMLParam("move","0");
    buttonFullScr.setXMLParam("toolTip","Restore");
    buttonLabel.setXMLParam("image","window.button.unfullscr.label");
  } else {
    parentLayout.resize(getPrivateInt("Anunaki",contName+"_lastX", 10),
			getPrivateInt("Anunaki",contName+"_lastY", 10),
			getPrivateInt("Anunaki",contName+"_lastW", 300),
			getPrivateInt("Anunaki",contName+"_lastH", 300));
    resizeDisabler.setXMLParam("ghost","1");
    resizeDisabler.setXMLParam("move","1");
    buttonFullScr.setXMLParam("toolTip",orgToolTip);
    buttonLabel.setXMLParam("image",orgLabel);
  }
}