/*************************************************************

  Anunaki - layouts.m
  by Leechbite

  - this script controls the layouts and auto-layouts
    of the skin.

*************************************************************/

#include <lib/std.mi>

// default layouts definition
#define CONTAINERLIST "Main,Pledit,Mlibrary,Video,Avs"
#define DEFAULTLAYOUT1 "Complete{main|normal|100,100,0,0;Pledit|normal|100,361,350,-411;AVS|normal|450,110,-550,170;MLibrary|normal|450,280,-550,-330}~"
#define DEFAULTLAYOUT2 "Fullscreen Layout 1{mlibrary|normal|0,0,-360,-0;AVS|normal|-360,0,360,200;pledit|normal|-360,200,360,-200;main}~"
#define DEFAULTLAYOUT3 "Fullscreen Layout 2{main;mlibrary|normal|0,0,-400,-0;Video|normal|-400,0,400,300;pledit|normal|-400,300,400,-300;main}~"
#define DEFAULTLAYOUT4 "Corner Shade{main|shade|-140,-221,0,0}~"
#define DEFAULTLAYOUT5 "Video/PL{main;Video|normal|30,100,-360,-200;pledit|normal|-330,100,300,-200}~"
#define DEFAULTLAYOUT6 ""
#define DEFAULTLAYOUT7 ""
#define DEFAULTLAYOUT8 ""
#define DEFAULTLAYOUT9 ""
#define DEFAULTLAYOUT10 ""
#define MAXNUMLAYOUTS 15

function setupAutoLayoutsMenu();
function executeAutoLayout(string token);
function string removeChar(string str, string substr);
function addCurrLayout();
function removeLayout(int layoutnum);
function inputBox();

Global group frameGroup;
Global container parentContainer;
Global layout parentLayout;
Global int layoutx, layouty;
Global string layoutPrivateInt;

Global button layoutButton;
Global popUpMenu layoutMenu, removelayoutsubmenu;

Global string autolayouts, curraddedlayout;
Global int numlayouts, numcustomlayouts;

Global container inputBoxCont;
Global text label;
Global edit inputfield;
Global button okbutton;

System.onScriptLoaded() {
  frameGroup = getScriptGroup();
  parentLayout = frameGroup.getParentLayout();
  parentContainer = parentLayout.getContainer();

  string Param = getParam();
  string buttonid = getToken(param, ",", 0);
  int defx = stringToInteger(getToken(param, ",", 1));
  int defy = stringToInteger(getToken(param, ",", 2));

  layoutButton = frameGroup.findObject(buttonid);

  layoutPrivateInt = parentContainer.getID()+"_"+parentlayout.getID();

  layoutx = getPrivateInt(getSkinName(), layoutPrivateInt+"_X", defx);
  layouty = getPrivateInt(getSkinName(), layoutPrivateInt+"_Y", defy);

  if (layoutx==defx) {
    setPrivateInt(getSkinName(), layoutPrivateInt+"_X", defx);
  }
  if (layouty==defy) {
    setPrivateInt(getSkinName(), layoutPrivateInt+"_Y", defy);
  }
}

system.onScriptUnloading() {
  parentContainer = NULL; // clears all events
  parentLayout = NULL;
  return;
}

parentLayout.onEndMove() {
  if (parentLayout.isVisible()) {
    setPrivateInt(getSkinName(), layoutPrivateInt+"_X", parentLayout.getLeft());
    setPrivateInt(getSkinName(), layoutPrivateInt+"_Y", parentLayout.getTop());
  }
}

parentContainer.onSwitchToLayout(layout newlayout) {
  if (!parentLayout.isVisible()) return; // if to different layout, exit

  string newlayoutPrivateInt = parentContainer.getID()+"_"+newlayout.getID();
  int newlayoutx = getPrivateInt(getSkinName(), newlayoutPrivateInt+"_X", 0);
  int newlayouty = getPrivateInt(getSkinName(), newlayoutPrivateInt+"_Y", 0);

  newlayout.resize(newlayoutx, newlayouty, newlayout.getWidth(), newlayout.getHeight());
}

//********** Auto-Layout Scripts ************

string removeChar(string mainstr, string substr) {
  int c, rem;
  string res="";

  do {
    c = strsearch(mainstr, substr);

    if (c>=0) {
      res = res + strleft(mainstr, c);
      rem = strlen(mainstr)-c-1;
      if (rem<=0) 
	mainstr=""; 
      else
	mainstr = strright(mainstr, rem);
    }
   
  } while (c>=0);
  res = res + mainstr;
  return res;
}

layoutButton.onRightButtonDown(int x, int y) {
  layout currlayout;
  int numLayouts = parentContainer.getNumLayouts();
  int c;

  autolayouts = DEFAULTLAYOUT1 + DEFAULTLAYOUT2 + DEFAULTLAYOUT3 + DEFAULTLAYOUT4 + DEFAULTLAYOUT5 +
		DEFAULTLAYOUT6 + DEFAULTLAYOUT7 + DEFAULTLAYOUT8 + DEFAULTLAYOUT9 + DEFAULTLAYOUT10
		+ getPrivateString(getSkinName(), "Auto-layouts", "");

  layoutMenu = new popUpMenu;
  layoutMenu.addCommand("- Player Modes -", -1, 0, 1);
  layoutMenu.addSeparator();

  for (c=0; c<=numLayouts; c++) {
    currlayout = parentContainer.enumLayout(c);

    if (currlayout!=NULL) {
      layoutMenu.addCommand(currlayout.getID(), c, currlayout.isVisible(), 0);
    }
  }
  setupAutoLayoutsMenu();

  int res = layoutMenu.popAtMouse();

  if ((res >= 0) && (res < 10)) {
    currlayout = parentContainer.enumLayout(res);

    parentContainer.switchToLayout(currlayout.getID());
  } else if ((res >= 100) && (res < 200)) {
    string tokenautolayout = getToken(autolayouts,"~",res-100);

    executeAutoLayout(tokenautolayout);
  } else if (res==1001) {
    addCurrLayout();
  } else if (res==2000) {
    int remres = messageBox("This will remove all existing custom layouts. Continue?", "Remove All Layouts", 12, "Confirm");
    if (remres==4) setPrivateString(getSkinName(), "Auto-layouts", "");
  } else if (res>2000) {
    removeLayout(res-2000);
  }

  delete layoutMenu;
  delete removelayoutSubMenu;

  complete;
}

setupAutoLayoutsMenu() {
  string tokenautolayout;
  string customlayouts;

  string layoutname;
  int startdata;
  int c = 0;

  layoutMenu.addSeparator();
  layoutMenu.addCommand("- Auto-Layouts -", -1, 0, 1);
  layoutMenu.addSeparator();

  numlayouts = 0;
  do {
    tokenautolayout = getToken(autolayouts,"~",c);
    if (tokenautolayout != "") {
      startdata = strsearch(tokenautolayout,"{");
      layoutname = strleft(tokenautolayout,startdata);
      layoutMenu.addCommand(layoutname, c+100, 0, 0);
    }
    c++;
  } while (tokenautolayout != "");

  numlayouts = c-1;

  layoutMenu.addSeparator();
  layoutMenu.addCommand("Save Current Layout", 1001, 0, numlayouts >= MAXNUMLAYOUTS);

  removelayoutSubMenu = new popUpMenu;
  removelayoutSubMenu.addCommand("Remove all layouts", 2000, 0, 0);
  removelayoutSubMenu.addSeparator();

  customlayouts = getPrivateString(getSkinName(), "Auto-layouts", "");

  numcustomlayouts = 0;
  c = 0;
  do {
    tokenautolayout = getToken(customlayouts,"~",c);
    if (tokenautolayout != "") {
      startdata = strsearch(tokenautolayout,"{");
      layoutname = strleft(tokenautolayout,startdata);
      removelayoutSubMenu.addCommand(layoutname, c+2001, 0, 0);
    }
    c++;
  } while (tokenautolayout != "");

  numcustomlayouts = c-1;

  layoutMenu.addSubMenu(removelayoutSubMenu, "Remove Layouts");
}

executeAutoLayout(string token) {
  string tokencont;
  int c = 0, x;

  container autocont;
  layout autolayout;

  string test;
  string tokenupper;
  string contid, contlayout, contcoord;
  int contx, conty, contw, conth;
  int realcontx, realconty, realcontw, realconth;
  int minw, minh, maxw, maxh;

  int startdata = strsearch(token,"{");
  int enddata = strsearch(token,"}");

  string layoutdata = strmid(token, startdata+1, enddata-startdata-1);

  c=0;

  tokenupper = strupper(removeChar(token," "));

  do {
    contid = strupper(getToken(CONTAINERLIST,",", c));
    c++;

    autocont = getContainer(contid);

    if (autocont!=NULL) {
      if (strsearch(tokenupper, contid) < 0) {
        for (x=0; x<=(autocont.getNumLayouts()-1); x++) {
	  autolayout = autocont.enumLayout(x);

	  if (autolayout.isVisible()) autocont.hide();
	}
      }
    }
  } while (contid != "");

  c=0;

  do {
    tokencont = getToken(layoutdata,";",c);
    if (tokencont != "") {
      contid = getToken(tokencont,"|",0);
      contlayout = getToken(tokencont,"|",1);
      contcoord = getToken(tokencont,"|",2);
      contx = stringToInteger(getToken(contcoord,",",0));
      conty = stringToInteger(getToken(contcoord,",",1));
      contw = stringToInteger(getToken(contcoord,",",2));
      conth = stringToInteger(getToken(contcoord,",",3));

      autocont = getContainer(contid);
      if (autocont==NULL) autocont =  newDynamicContainer(contid); // incase its dynamic and closed.
      if (autocont!=NULL) {

	autolayout = NULL;
	if (contlayout!="") {
	  autocont.switchToLayout(contlayout);
	  autolayout = autocont.getLayout(contlayout);

	  if (!autolayout.isVisible()) {
	    autolayout.show();
	  }
	} else { // *** if contlayout is empty, search for current layout.
	  x=0;
	  do {
	    autolayout = autocont.enumLayout(x);
	    x++;
          } while ((!autolayout.isVisible()) && (x<=autocont.getNumLayouts()));
	}
	if ((autolayout!=NULL) && (strleft(getToken(contcoord,",",0),1)!="")) {
	  if (strleft(getToken(contcoord,",",0),1)=="-")
	    realcontx = getViewPortLeft() + getViewPortWidth() + contx;
	  else
	    realcontx = getViewPortLeft() + contx;

	  if (strleft(getToken(contcoord,",",1),1)=="-") 
	    realconty = getViewPortTop() + getViewPortHeight() + conty;
	  else
	    realconty = getViewPortTop() + conty;

	  if (strleft(getToken(contcoord,",",2),1)=="-") 
	    realcontw = getViewPortLeft() + getViewPortWidth() + contw;
	  else
	    realcontw = contw;

	  if (strleft(getToken(contcoord,",",3),1)=="-") 
	    realconth = getViewPortTop() + getViewPortHeight() + conth;
	  else
	    realconth = conth; 

	  minw = stringToInteger(autolayout.getXMLParam("minimum_w"));
	  minh = stringToInteger(autolayout.getXMLParam("minimum_h"));
	  maxw = stringToInteger(autolayout.getXMLParam("maximum_w"));
	  maxh = stringToInteger(autolayout.getXMLParam("maximum_h"));

	  if ((realcontw < minw) && (minw!=0)) realcontw=minw;
	  if ((realconth < minh) && (minh!=0)) realconth=minh;
	  if ((realcontw > maxw) && (maxw!=0)) realcontw=maxw;
	  if ((realconth > maxh) && (maxh!=0)) realconth=maxh;

	  autolayout.resize(realcontx, realconty, realcontw, realconth);
	} else if (autolayout!=NULL) autolayout.setFocus();

      }
    }
    c++;
  } while (tokencont != "");

  //int res = messageBox(autolayouts, "Auto Layout Test", 1, "test");
}

addCurrLayout() {
  string currentlayout = "";
  string contid;
  
  container autocont;
  layout autolayout;
  int lx, ly, lw, lh;

  boolean exitloop;

  int c = 0, x;

  currentlayout = "";
  
  do {
    contid = getToken(CONTAINERLIST,",", c);
    c++;

    autocont = NULL;
    autocont = getContainer(contid);

    if (autocont!=NULL) {
      x = 0;
      do {
	autolayout = autocont.enumLayout(x);
	x++;

	if (autolayout!=NULL)
	  exitloop = (!autolayout.isVisible()) && (x<=autocont.getNumLayouts());
	else
	  exitloop = 0;
        
      } while (exitloop);

      if (autolayout!=NULL) {
      if (autolayout.isVisible()) {

	lx = autolayout.getLeft();
	ly = autolayout.getTop();
	lw = autolayout.getWidth();
	lh = autolayout.getHeight();

	if (lx < 0) lx = 0;
	if (ly < 0) ly = 0;
	if (lw < 0) lw = 0;
	if (lh < 0) lh = 0;

	currentlayout += contid+"|"+autolayout.getID()+"|";
	currentlayout += integerToString(lx)+",";
	currentlayout += integerToString(ly)+",";
	currentlayout += integerToString(lw)+",";
	currentlayout += integerToString(lh)+";";
      } }

    }
  } while (contid != "");

  currentlayout += "}";

  curraddedlayout = currentlayout;

  inputBox();
}

removeLayout(int layoutnum) {
  string customlayouts = getPrivateString(getSkinName(), "Auto-layouts", "");
  string newcustomlayouts = "";
  string tokenlayout;
  int c=0;

  do {
    tokenlayout = getToken(customlayouts, "~", c);
    c++;
    if ((tokenlayout!="") && (c!=layoutnum)) {
      newcustomlayouts += tokenlayout+"~";
    }
  } while (tokenlayout!="");

  setPrivateString(getSkinName(), "Auto-layouts", newcustomlayouts);
}

InputBox() {
  string customlayouts = getPrivateString(getSkinName(), "Auto-layouts", "");
  string newlayoutstring;
  string newlayoutname = "USER Layout "+integerToString(numcustomlayouts+1);
  
  inputboxcont = getContainer("InputBox");
  if (inputboxcont==NULL) inputboxcont = newDynamicContainer("InputBox");

  if (inputboxcont==NULL) {
    newlayoutstring = "~"+newlayoutname+"{"+curraddedlayout;
    customlayouts += newlayoutstring;
    setPrivateString(getSkinName(), "Auto-layouts", customlayouts);
  } else {
    layout inputboxlayout = inputboxcont.getLayout("normal");
    inputboxcont.setName("Save Layout");
    label = inputboxlayout.findObject("label");
    inputfield = inputboxlayout.findObject("inputfield");
    okbutton = inputboxlayout.findObject("ok");

    label.setText("Enter new layout name:");
    inputfield.setText(newlayoutname);
    inputboxlayout.resize(getViewPortLeft()+(getViewPortWidth()-inputboxlayout.getWidth())/2,
			getViewPortTop()+(getViewPortHeight()-inputboxlayout.getHeight())/2,
			inputboxlayout.getWidth(), inputboxlayout.getHeight());

    inputboxlayout.show();
  }
}

inputfield.onEnter() {
  string customlayouts = getPrivateString(getSkinName(), "Auto-layouts", "");
  string newlayoutstring;
  string newlayoutname;

  newlayoutname = removeChar(strleft(getText(),20),"~");
  newlayoutname = removeChar(newlayoutname,"{");
  newlayoutname = removeChar(newlayoutname,"}");
  if (newlayoutname == "") newlayoutname=" ";

  newlayoutstring = newlayoutname+"{"+curraddedlayout+"~";
  customlayouts += newlayoutstring;
  setPrivateString(getSkinName(), "Auto-layouts", customlayouts);

  inputboxcont.close();
}

okbutton.onLeftClick() { inputfield.onEnter(); }
