/*************************************************************

  Anunaki - ml.m
  by Leechbite

  - this script controls media libary and its contents.

*************************************************************/

#include <lib/std.mi>
#include "attribs.m"

Global group frameGroup;
Global group componentgroup, menugroup;
Global button menutoggler, managepl;
Global boolean menuopen;

System.onScriptLoaded() {
  initAttribs();

  frameGroup = getScriptGroup();

  componentgroup = frameGroup.findObject("mlibrary.component.group");
  menugroup = frameGroup.findObject("ml.menu");
  menutoggler = frameGroup.findObject("menu.toggler");

  menubar_ml_attrib.onDataChanged();

  componentgroup.onResize(0, 0, 100, 100); // values doesnt really matter
}

system.onScriptUnloading() {
  return;
}

menubar_ml_attrib.onDataChanged() {
  menuopen = (getData()=="1");

  if (menuopen) {
    menugroup.show();
    menutoggler.setXMLParam("y","14");
    menutoggler.setXMLParam("image","window.menu.toggle");
    menutoggler.setXMLParam("downimage","window.menu.toggle.down");
    menutoggler.setXMLParam("hoverimage","window.menu.toggle.hover");

    componentgroup.setXMLParam("y","20");
    componentgroup.setXMLParam("h","-20");
  } else {
    menugroup.hide();
    menutoggler.setXMLParam("y","0");
    menutoggler.setXMLParam("image","window.menu.toggle.open");
    menutoggler.setXMLParam("downimage","window.menu.toggle.down.open");
    menutoggler.setXMLParam("hoverimage","window.menu.toggle.hover.open");

    componentgroup.setXMLParam("y","6");
    componentgroup.setXMLParam("h","-6");
  }

  componentgroup.onResize(0, 0, 100, 100); // values doesnt really matter
}

menutoggler.onLeftClick() {
  menuopen = !menuopen;

  menubar_ml_attrib.setData(integerTostring(menuopen));
}

componentgroup.onResize(int x, int y, int w, int h) {
  int compwid = componentgroup.getWidth();

  int buttonx = (compwid-menutoggler.getWidth())/2;

  if ((buttonx < 150) && (menuopen)) buttonx=150;

  menutoggler.setXMLParam("x", integerToString(buttonx));

}

System.onKeyDown(String k) {

  if ((k == "alt") && (!menuopen)) menutoggler.LeftClick();
  Layout l = frameGroup.getParentLayout();
  if (!l.isActive()) return;
  if (k == "alt+f") {
	if (!menuopen) menutoggler.LeftClick();

	getScriptGroup().findObject("ml.menu.File").sendAction("open", "", 0, 0, 0, 0);
	complete;
  }
  if (k == "alt+v") {
	if (!menuopen) menutoggler.LeftClick();

	getScriptGroup().findObject("ml.menu.View").sendAction("open", "", 0, 0, 0, 0);
	complete;
  }
  if (k == "alt+h") {
	if (!menuopen) menutoggler.LeftClick();

	getScriptGroup().findObject("ml.menu.Help").sendAction("open", "", 0, 0, 0, 0);
	complete;
  }
}