/*************************************************************

  Anunaki - pledit.m
  by Leechbite

  - this script controls playlist editor and its contents.

*************************************************************/

#include <lib/std.mi>
#include "attribs.m"

Global group frameGroup;
Global group componentgroup, menugroup;
Global button menutoggler, managepl;
Global boolean menuopen;

System.onScriptLoaded() {
  initAttribs();

  frameGroup = getScriptGroup();

  componentgroup = frameGroup.findObject("pl.component");
  menugroup = frameGroup.findObject("pl.menu");
  menutoggler = frameGroup.findObject("menu.toggler");

  managepl = frameGroup.findObject("pl.List");

  menubar_pe_attrib.onDataChanged();

  componentgroup.onResize(0, 0, 100, 100); // values doesnt really matter
}

system.onScriptUnloading() {
  return;
}

menubar_pe_attrib.onDataChanged() {
  menuopen = (getData()=="1");

  if (menuopen) {
    menugroup.show();
    menutoggler.setXMLParam("y","14");
    menutoggler.setXMLParam("image","window.menu.toggle");
    menutoggler.setXMLParam("downimage","window.menu.toggle.down");
    menutoggler.setXMLParam("hoverimage","window.menu.toggle.hover");

    componentgroup.setXMLParam("y","20");
    componentgroup.setXMLParam("h","-20");
  } else {
    menugroup.hide();
    menutoggler.setXMLParam("y","0");
    menutoggler.setXMLParam("image","window.menu.toggle.open");
    menutoggler.setXMLParam("downimage","window.menu.toggle.down.open");
    menutoggler.setXMLParam("hoverimage","window.menu.toggle.hover.open");

    componentgroup.setXMLParam("y","6");
    componentgroup.setXMLParam("h","-6");
  }

  componentgroup.onResize(0, 0, 100, 100); // values doesnt really matter
}

menutoggler.onLeftClick() {
  menuopen = !menuopen;

  menubar_pe_attrib.setData(integerTostring(menuopen));
}

componentgroup.onResize(int x, int y, int w, int h) {
  int compwid = componentgroup.getWidth();

  int buttonx = (compwid-menutoggler.getWidth())/2;

  if ((buttonx < 180) && (menuopen)) buttonx=180;

  menutoggler.setXMLParam("x", integerToString(buttonx));

  if ((compwid < 270) && (menuopen))
    menutoggler.hide();
  else
    menutoggler.show();

  guiobject manageplparent = managepl.getParent();
  if (compwid > 355) {
    manageplparent.setXMLParam("w","90");
    manageplparent.setXMLParam("x","-90");
    manageplparent.show();
  } else if (compwid > 290) {
    manageplparent.setXMLParam("w",integerToString(compwid - 265));
    manageplparent.setXMLParam("x",integerToString(265 - compwid));
    manageplparent.show();
  } else
    manageplparent.hide();
}

System.onKeyDown(String k) {

  if ((k == "alt") && (!menuopen)) menutoggler.LeftClick();
  Layout l = frameGroup.getParentLayout();
  if (!l.isActive()) return;
  if (k == "alt+f") {
	if (!menuopen) menutoggler.LeftClick();

	getScriptGroup().findObject("pl.menu.File").sendAction("open", "", 0, 0, 0, 0);
	complete;
  }
  if (k == "alt+p") {
	if (!menuopen) menutoggler.LeftClick();

	getScriptGroup().findObject("pl.menu.Playlist").sendAction("open", "", 0, 0, 0, 0);
	complete;
  }
  if (k == "alt+s") {
	if (!menuopen) menutoggler.LeftClick();

	getScriptGroup().findObject("pl.menu.Sort").sendAction("open", "", 0, 0, 0, 0);
	complete;
  }
  if (k == "alt+h") {
	if (!menuopen) menutoggler.LeftClick();

	getScriptGroup().findObject("pl.menu.Help").sendAction("open", "", 0, 0, 0, 0);
	complete;
  }
}