/*************************************************************

  Anunaki - seeker.m
  by Leechbite

  - this script controls the seeker

*************************************************************/


#include <lib/std.mi>
#include "temptext.m"

function updateseeker(int x);

Global group frameGroup;
Global guiObject seekerbase, seeker;
Global slider seekerslider;
Global int w;
Global boolean seekChanging;

System.onScriptLoaded() {
  tempTextload();

  frameGroup = getScriptGroup();

  seekerbase = frameGroup.getObject("seeker.base");
  seeker = frameGroup.getObject("seeker");
  seekerslider= frameGroup.getObject("hideseek");
}

system.onScriptUnloading() {
  tempTextUnload();
}

seekerslider.onPostedPosition(int p) {
  if (SeekChanging) return;
  w = seekerbase.getWidth();
  seeker.setXMLParam("w", integerToString(p*w/255));
}

seekerBase.onLeftButtonDown(int x, int y) {
  if (getPlayItemLength() > 0) { 
    SeekChanging = 1;
    updateSeeker(x);
  }
}

seekerBase.onLeftButtonUp(int x, int y) {
  float l;
  if (SeekChanging) {

    int p = x - seekerbase.getLeft();
    w = seekerbase.getWidth();
    if (p > w) p=w;
    if (p < 0) p=0;
    l = p*255/w;

    if (l >= 0) {
      if (System.getPlayItemLength() >= 0) {
	l = l * System.getPlayItemLength()/255;
	System.seekTo(l);
      }
    }
    SeekChanging = 0;
  }
}

seekerBase.onMouseMove(int x, int y) {
	if (SeekChanging) {
		updateSeeker(x);
	}
}

updateSeeker(int x) {
	if (!seeker.isVisible()) return;

	p = x - seekerbase.getLeft();
	w = seekerbase.getWidth();
	if (p > w) p=w;
	if (p < 0) p=0;
	if (p >= 0) {

		seeker.setXMLParam("w", integerToString(p));

		float len = System.getPlayItemLength();
		int s = (p * len) / w;
		setTempText("Seek: " + System.integerToTime(s) + " / " + 
				System.integerToTime(len));
	}
}