/*************************************************************

  Anunaki - songticker-fs.m
  by Leechbite

  - this script controls the fullscreen songticker and 
    the temporary text messages, like volume changes, seeker,
    etc..

*************************************************************/

#include <lib/std.mi>
#include "attribs.m"

function setTempText(string txt);
function setTickerAlphas(int A1, int A2, int A3);
function int getSongtickerMode();
function setsongtickerMode(int mode);

Global group frameGroup;
Global text txtartist, txttitle, txtyear, txtalbum, temptext;
Global string strartist, strtitle, stryear, stralbum;

Global text remoteTempText;

Global timer tempdelay;

Global boolean localChange = 0;

System.onScriptLoaded() {
  initattribs();

  frameGroup = getScriptGroup();

  txtartist = frameGroup.getObject("artist");
  txttitle = frameGroup.getObject("title");
  txtalbum = frameGroup.getObject("album");
  txtyear = frameGroup.getObject("year");
  temptext = frameGroup.getObject("temptext");

  tempdelay = new timer;
  tempdelay.setDelay(2000);
  
  onTitleChange("");

  layout mainnormal = getContainer("main").getLayout("normal");
  remoteTempText = mainnormal.findObject("tempText");
}

system.onScriptUnLoading() {
  delete tempdelay;
  remoteTempText = NULL;
}

system.onTitleChange(string newtitle) {
  strartist = getPlayItemMetaDataString("Artist");
  strtitle = getPlayItemMetaDataString("Title");
  stralbum = getPlayItemMetaDataString("Album");
  stryear = getPlayItemMetaDataString("Year");

  if (strartist=="") strartist="no artist";
  if (stralbum=="") stralbum="----";
  if (stryear=="") stryear="----";

  txtartist.setText(strartist);
  txttitle.setText(strtitle);

  int albumwidth = (frameGroup.getWidth()-120)/2 - (txtartist.getAutoWidth()/2);
  if (albumwidth < 100) albumwidth = 100;

  txtalbum.setXMLParam("x", integerToString(-albumwidth-60));
  txtalbum.setXMLParam("w", integerToString(albumwidth));

  do {
    txtalbum.setText("Album[ "+stralbum+" ]");
    stralbum = strleft(stralbum, strlen(stralbum)-1);
  } while ((txtalbum.getAutoWidth() > albumwidth) && (stralbum!=""));
  txtyear.setText("Year[ "+stryear+" ]");


  /*if ( (frameGroup.getWidth()-txtalbum.getAutoWidth()) < ((txtartist.getAutoWidth() + frameGroup.getWidth())/2) ) {
    txtalbum.hide();
  } else {
    txtalbum.show();
  }*/
}

frameGroup.onResize(int x, int y, int w, int h) {
  system.onTitleChange("");
}

// ********* Temp Text Scripts **************
setTempText(string txt) {
  temptext.setText(txt);
  temptext.show();

  setTickerAlphas(0,0,0);

  tempdelay.start();
}

tempdelay.onTimer() {
  stop();

  setTickerAlphas(255,160,255);

  temptext.hide();

  remoteTempText.setText("");
}

setTickerAlphas(int A1, int A2, int A3) {
  txtartist.setAlpha(A2);
  txttitle.setAlpha(A3);
}

remoteTempText.onTextChanged(string newtxt) {
  if (newtxt!="")
    setTempText(newtxt);
  else if (!tempdelay.isRunning()){
    tempdelay.stop();
    tempdelay.onTimer();
  }
}
