/*************************************************************

  Anunaki - songticker.m
  by Leechbite

  - this script controls the special songticker and 
    the temporary text messages, like volume changes, seeker,
    etc..

*************************************************************/

#include <lib/std.mi>
#include "attribs.m"

function int charCount(string str, string subchar);
function SetSongticker(int mode);

function setTempText(string txt);
function setTickerAlphas(int A1, int A2, int A3);
function int getSongtickerMode();
function setsongtickerMode(int mode);

Global group frameGroup;
Global text songticker, txtartist, txttitle, temptext;
Global string strartist, strtitle;
Global int startx, totalwidth, midspace, align;
Global int maxwid,Wwid,Iwid;
Global boolean dynamicWidth;
Global int rightspace;

Global boolean classicoveride;

Global int songtickermode;
Global popupMenu songtickerMenu;

global text dummytxtartist, dummytxttitle; // text value set by main.m (songinfo.m)

Global timer songtickerdelay;

Global timer tempdelay;
Global text remoteTempText;

Global boolean localChange = 0;

System.onScriptLoaded() {
  initattribs();

  frameGroup = getScriptGroup();

  string Param = getParam();
  startx = stringToInteger(getToken(param, ",", 0));
  maxwid = stringToFloat(getToken(param, ",", 1));
  totalwidth = stringToInteger(getToken(param, ",", 2));
  midspace = stringToInteger(getToken(param, ",", 3));
  align = stringToInteger(getToken(param, ",", 4));

  dynamicWidth = (totalwidth < 0);
  if (dynamicWidth) {
    rightspace = (-totalwidth) - startx;
    totalwidth = frameGroup.getWidth() - startx - rightspace;
  }

  songticker = frameGroup.getObject("songticker");
  txtartist = frameGroup.getObject("artist");
  txttitle = frameGroup.getObject("title");
  temptext = frameGroup.getObject("temptext");

  songtickermode = getsongtickermode();

  songtickerdelay = new timer;
  songtickerdelay.setDelay(2000);

  songtickerMenu = new popupMenu;
  songtickerMenu.addCommand("- Songticker -", -1, 0, 1);
  songtickerMenu.addSeparator();
  songtickerMenu.addCommand("Classic No Scroll", 0, songtickermode==0, 0);
  songtickerMenu.addCommand("Classic Scroll", 1, songtickermode==1, 0);
  songtickerMenu.addCommand("Anunaki Songticker", 2, songtickermode==2, 0);

  tempdelay = new timer;
  tempdelay.setDelay(2000);
 
  layout mainnormal = getContainer("main").getLayout("normal");
  remoteTempText = mainnormal.findObject("tempText");

  dummytxtartist = mainnormal.findObject("dummy.txtartist");
  dummytxttitle = mainnormal.findObject("dummy.txttitle");

  //onTitleChange("");
  dummytxttitle.onTextChanged("");
}

system.onScriptUnLoading() {
  delete songtickerMenu;
  delete tempdelay;
  remoteTempText = NULL;
  dummytxtartist = NULL;
  dummytxttitle = NULL;
}

int getSongtickerMode() {
  if (songticker_anunaki_attrib.getData()=="1") return 2;
  if (songticker_classicscroll_attrib.getData()=="1") return 1;
  if (songticker_classicnoscroll_attrib.getData()=="1") return 0;

  return 0;
}

songticker_anunaki_attrib.onDataChanged() {
  if ((getData()=="0") || (localchange)) return;

  songtickermode = 2;

  songtickerMenu.checkCommand(0, songtickermode==0);
  songtickerMenu.checkCommand(1, songtickermode==1);
  songtickerMenu.checkCommand(2, songtickermode==2);

  dummytxttitle.onTextChanged(""); // refreshes the songticker.
}

songticker_classicscroll_attrib.onDataChanged() {
  if ((getData()=="0") || (localchange)) return;

  songtickermode = 1;

  songtickerMenu.checkCommand(0, songtickermode==0);
  songtickerMenu.checkCommand(1, songtickermode==1);
  songtickerMenu.checkCommand(2, songtickermode==2);

  dummytxttitle.onTextChanged(""); // refreshes the songticker.
}

songticker_classicnoscroll_attrib.onDataChanged() {
  if ((getData()=="0") || (localchange)) return;

  songtickermode = 0;

  songtickerMenu.checkCommand(0, songtickermode==0);
  songtickerMenu.checkCommand(1, songtickermode==1);
  songtickerMenu.checkCommand(2, songtickermode==2);

  dummytxttitle.onTextChanged(""); // refreshes the songticker.
}

setsongtickerMode(int mode) {

  localchange = 1;

  if (mode==2) (songticker_anunaki_attrib.setData("1"));
  if (mode==1) (songticker_classicscroll_attrib.setData("1"));
  if (mode==0) (songticker_classicnoscroll_attrib.setData("1"));

  localchange = 0;

  songtickermode = mode;

  songtickerMenu.checkCommand(0, mode==0);
  songtickerMenu.checkCommand(1, mode==1);
  songtickerMenu.checkCommand(2, mode==2);
}

setsongticker(int mode) {
  setSongtickerMode(mode);

  if (mode==0) {
    songticker.setXMLParam("ticker","0");
  } else {
    songticker.setXMLParam("ticker","1");
  }

  if ((mode!=2) || (classicOveride)) {
    txtartist.hide();
    txttitle.hide();
    songticker.show();
  } else {
    txtartist.show();
    txttitle.show();
    songticker.hide();
  }

}

txtartist.onRightButtonDown(int x, int y) {
  int mode = songtickerMenu.popAtMouse();

  if (mode>=0) Setsongticker(mode);

  complete;

  dummytxttitle.onTextChanged(""); // refreshes the songticker.
}

txttitle.onRightButtonDown(int x, int y) {
  int mode = songtickerMenu.popAtMouse();

  if (mode>=0) Setsongticker(mode);

  complete;

  dummytxttitle.onTextChanged(""); // refreshes the songticker.
}

songticker.onRightButtonDown(int x, int y) {
  int mode = songtickerMenu.popAtMouse();

  if (mode>=0) Setsongticker(mode);

  complete;

  dummytxttitle.onTextChanged(""); // refreshes the songticker.
}

songtickerdelay.onTimer() {
  if (txtartist.isVisible()) {
    txtartist.hide();
    txttitle.show();
  } else {
    txtartist.show();
    txttitle.hide();
  }
}

dummytxttitle.onTextChanged(string newtxt) {
  strartist = dummytxtartist.getText();
  if (strartist=="") strartist = getPlayItemMetaDataString("Artist");
  strtitle = dummytxttitle.getText();
  if (strtitle=="") strtitle = getPlayItemMetaDataString("Title");

  int totlength;
  int txtartistwidth, txttitlewidth;
  int middle;

  if (dynamicWidth) {
    totalwidth = frameGroup.getWidth() - startx - rightspace;
    maxwid = totalwidth / 2;
  }

    txtartist.setText(strartist);
    txttitle.setText(strtitle);

    txtartistwidth = txtartist.getAutoWidth();
    txttitlewidth = txttitle.getAutoWidth();
    totlength = txtartistwidth + txttitlewidth + midspace;

    if (align == 1) { // align to left  
      middle = txtartistwidth;
    } else {
      middle = (totalwidth-totlength)/2+txtartistwidth;
    }

    if (middle < 0) middle=0;

    if (totalwidth < totlength) {  // if songticker too long too display, do the switching thing

      if (align == 1) {
        txtartist.setXMLParam("w", integerToString(totalwidth));
        txttitle.setXMLParam("x", integerToString(startx));
	if (!dynamicwidth)
          txttitle.setXMLParam("w", integerToString(totalwidth));
	else
          txttitle.setXMLParam("w", integerToString(-startx-rightspace));
	txtartist.setXMLParam("align","left");
	txttitle.setXMLParam("align","left");
      } else {
        txtartist.setXMLParam("w", integerToString(totalwidth));
        txttitle.setXMLParam("x", integerToString(startx));
	if (!dynamicwidth)
          txttitle.setXMLParam("w", integerToString(totalwidth));
	else
          txttitle.setXMLParam("w", integerToString(-startx-rightspace));
	txtartist.setXMLParam("align","center");
	txttitle.setXMLParam("align","center");
      }
      if (!songtickerdelay.isRunning()) {
	songtickerdelay.onTimer();
	songtickerdelay.start();
      }

    } else {

      txtartist.setXMLParam("w", integerToString(middle));
      txttitle.setXMLParam("x", integerToString(middle+midspace+startx));
      if (!dynamicwidth) 
        txttitle.setXMLParam("w", integerToString(totalwidth-middle-midspace));
      else 
        txttitle.setXMLParam("w", integerToString(-(middle+midspace+startx+rightspace)));

      if (songtickerdelay.isRunning()) songtickerdelay.stop();
      txtartist.show();
      txttitle.show();
      txtartist.setXMLParam("align","right");
      txttitle.setXMLParam("align","left");

    }

  classicOveride = 0;
  if ((strartist!="") && (strtitle!="") && (songtickermode==2)) {
    if (!songtickerdelay.isRunning()) {	
      txtartist.show();
      txttitle.show();
    }
    songticker.hide();
  } else {
    if (songtickerdelay.isRunning()) songtickerdelay.stop();
    txtartist.hide();
    txttitle.hide();
    songticker.show();
    classicOveride == (songtickermode==2);
    if (songtickermode==0) {
      songticker.setXMLParam("ticker","0");
    } else {
      songticker.setXMLParam("ticker","1");
    }
  }
}

frameGroup.onResize(int x, int y, int w, int h) {
  dummytxttitle.onTextChanged("");
}

// ********* Temp Text Scripts **************
setTempText(string txt) {
  temptext.setText(txt);
  temptext.show();

  setTickerAlphas(0,0,0);

  tempdelay.start();
}

tempdelay.onTimer() {
  stop();

  setTickerAlphas(255,160,255);

  temptext.hide();

  remoteTempText.setText("");
}

setTickerAlphas(int A1, int A2, int A3) {
  songticker.setAlpha(A1);
  txtartist.setAlpha(A2);
  txttitle.setAlpha(A3);
}

remoteTempText.onTextChanged(string newtxt) {
  if (newtxt!="")
    setTempText(newtxt);
  else if (!tempdelay.isRunning()){
    tempdelay.stop();
    tempdelay.onTimer();
  }
}
