/*********************

default standardframe.m
modified by Leechbite

*********************/

#include <lib/std.mi>

#define FALSE 0
#define TRUE 1

function beatvisSetAlpha(int left, int right);

Global Group frameGroup, content, titlebar;
Global Text titlebar;
Global String x, y, w, h, rx, ry, rw, rh;
Global Layer mouselayer;
Global Button Sysmenu;

Global layout groupLayout;
Global layer windowleft1, windowleft2, windowleft3;
Global layer windowright1, windowright2, windowright3;

Global group windowregions;
Global layer lefttopregion, leftregion, righttopregion, rightregion;
Global layer handlelefttop, handleleft, handlerighttop, handleright;
Global layer handlegroveleft, handlegroveright;
Global layer ventleft, ventright;
Global layer glowleft, glowright;

Global layer shutter, shuttertop, shutterbottom;
Global boolean shutterclosing;
Global guiObject shuttercloser;

Global animatedLayer volume;
Global boolean voladjust;

// standard-frame beat vis :D
#define BEAT_VU 10
#define BEAT_BASS 11
#define BEAT_TREBLE 12

#define BEAT_OFF 0
#define BEAT_STAY 1
#define BEAT_ON 2
#define BEAT_REV 3

global timer refreshBeat, delay;
global int deltaapha, beatmode, beatsource;
global int lastvuleft, lastvuright, maxvu;
global popupMenu beatvismenu;
global boolean visupdating;

Function setNewGroup(String groupid);

System.onScriptLoaded() {
  frameGroup = getScriptGroup();

  String param = getParam();
  x = getToken(param, ",", 0);
  y = getToken(param, ",", 1);
  w = getToken(param, ",", 2);
  h = getToken(param, ",", 3);
  rx = getToken(param, ",", 4);
  ry = getToken(param, ",", 5);
  rw = getToken(param, ",", 6);
  rh = getToken(param, ",", 7);
  sysmenu = frameGroup.findObject("sysmenu");

  titlebar = frameGroup.findObject("titlebar");

  groupLayout = frameGroup.getParentLayout();
  windowleft1 = frameGroup.findObject("window.left1");
  windowleft2 = frameGroup.findObject("window.left2");
  windowleft3 = frameGroup.findObject("window.left3");
  windowright1 = frameGroup.findObject("window.right1");
  windowright2 = frameGroup.findObject("window.right2");
  windowright3 = frameGroup.findObject("window.right3");

  windowregions = frameGroup.findObject("wasabi.frame.regions");
  lefttopregion = windowregions.getObject("window.left.top.region");
  leftregion = windowregions.getObject("window.left.region");
  righttopregion = windowregions.getObject("window.right.top.region");
  rightregion = windowregions.getObject("window.right.region");

  handlelefttop = frameGroup.findObject("window.handle.left.top");
  handleleft = frameGroup.findObject("window.handle.left");
  handlerighttop = frameGroup.findObject("window.handle.right.top");
  handleright = frameGroup.findObject("window.handle.right");
  handlegroveleft = frameGroup.findObject("window.handle.grove.left");
  handlegroveright = frameGroup.findObject("window.handle.grove.right");

  ventleft = frameGroup.findObject("window.vent.left");
  ventright = frameGroup.findObject("window.vent.right");

  // ************** shutter init ******************
  shutter = frameGroup.findObject("window.shutter");
  shuttertop = frameGroup.findObject("window.shutter.top");
  shutterbottom = frameGroup.findObject("window.shutter.bottom");
  shuttercloser = frameGroup.findObject("window.shutter.closer");
  shuttertop.setTargetSpeed(1.0);
  shutterbottom.setTargetSpeed(1.0);
  shutterclosing = 0;

  // ************* volume init ********************
  volume = frameGroup.findObject("volume");
  voladjust = 0;
  system.onVolumeChanged(getVolume());

  // ************** beat vis init *********************

  glowleft = frameGroup.findObject("window.glow.left");
  glowright = frameGroup.findObject("window.glow.right");

  deltaapha = 25;
  lastvuleft = 0; lastvuright=0;
  maxvu = 15;
  visupdating = FALSE;

  refreshBeat = new timer;
  refreshBeat.setDelay(50);

  delay = new timer;
  delay.setDelay(100);
  delay.start();
}

System.onScriptUnloading() {
  delete refreshBeat;
}

System.onSetXuiParam(String param, String value) {
  if (param == "content") {
    setNewGroup(value);
    titlebar = frameGroup.findObject("titlebar");
    mouselayer = titlebar.findObject("mousetrap");
  }
  if (param == "padtitleright" || param == "padtitleleft") {
    if (titlebar != NULL) titlebar.setXmlParam(param, value); 
  }
  if (param == "shade") {
    if (mouselayer != NULL) mouselayer.setXmlParam("dblclickaction", "switch;"+value);
    else messagebox("Cannot set shade parameter for StandardFrame object, no mousetrap found", "Skin Error", 0, "");
  }
}

// backward compatibility for prerelease notify trick
frameGroup.onNotify(String cmd, String param, int a, int b) {
  String _command = getToken(cmd, ",", 0);
  String _param = getToken(cmd, ",", 1);
  if (_command == "content" || _command == "padtitleright" || _command == "padtitleleft" || _command == "shade") {
    onSetXuiParam(_command, _param);
  }
}

setNewGroup(String groupid) {
  content = newGroup(groupid);
  if (content == NULL) {
    messagebox("group \"" + groupid + "\" not found", "ButtonGroup", 0, "");
    return;
  }
  content.setXmlParam("x", x);
  content.setXmlParam("y", y);
  content.setXmlParam("w", w);
  content.setXmlParam("h", h);
  content.setXmlParam("relatx", rx);
  content.setXmlParam("relaty", ry);
  content.setXmlParam("relatw", rw);
  content.setXmlParam("relath", rh);
  content.init(frameGroup);
}

Sysmenu.onLeftClick() {
  LayoutStatus _status = frameGroup.findObject("sysmenu.status");
  _status.callme("{system}");
}

// ****************************** Standard frame extensions *********************

delay.onTimer() {
  // repeat this code until titlebar produces proper component name
  if (titlebar.getText()==":componentname") return;

  stop(); // finally component name found.. 

  beatmode = getPrivateInt("Anunaki", titlebar.getText()+"_Beat Mode", BEAT_OFF);
  beatsource = getPrivateInt("Anunaki", titlebar.getText()+"_Beat Source", BEAT_VU);

  if ((beatmode==BEAT_ON) || (beatmode==BEAT_REV))
    refreshBeat.start();
  if (beatmode==BEAT_STAY)
    beatvisSetAlpha(255,255);

  if (getPrivateInt("Anunaki", titlebar.getText()+"_ShutterClose", 1)==0) 
    shutter.onLeftButtonUp(0,0);
}

groupLayout.onResize(int gx, int gy, int gw, int gh) {

  int midpoint = (gh-116)/3;
  if (midpoint<0) midpoint=0;

  windowleft1.setXMLParam("h", integerToString(midpoint));
  int left2y = midpoint + windowleft1.getTop();
  windowleft2.setXMLParam("y", integerToString(left2y));
  int left3y = left2y + windowleft2.getHeight();
  windowleft3.setXMLParam("y", integerToString(left3y));
  windowleft3.setXMLParam("h", integerToString(-(left3y+ 75)));

  windowright1.setXMLParam("h", integerToString(midpoint));
  windowright2.setXMLParam("y", integerToString(left2y));
  windowright3.setXMLParam("y", integerToString(left3y));
  windowright3.setXMLParam("h", integerToString(-(left3y+ 75)));

  lefttopregion.setXMLParam("y", integerToString(left2y+2));
  leftregion.setXMLParam("y", integerToString(left2y+5));
  leftregion.setXMLParam("h", integerToString(-(left2y+5+68)));

  righttopregion.setXMLParam("y", integerToString(left2y+2));
  rightregion.setXMLParam("y", integerToString(left2y+5));
  rightregion.setXMLParam("h", integerToString(-(left2y+5+68)));

  // **** left/right handles

  handlelefttop.setXMLParam("y", integerToString(midpoint+45));
  handleleft.setXMLParam("y", integerToString(midpoint+60));
  handleleft.setXMLParam("h", integerToString(-(midpoint+142)));

  handlerighttop.setXMLParam("y", integerToString(midpoint+45));
  handleright.setXMLParam("y", integerToString(midpoint+60));
  handleright.setXMLParam("h", integerToString(-(midpoint+142)));

  handlegroveleft.setXMLParam("y", integerToString(gh*2/3-37));
  handlegroveright.setXMLParam("y", integerToString(gh*2/3-37));

  // **** vents & glows

  int ventrealheight = midpoint+8;
  int ventnum = ventrealheight/17;
  int ventheight = ventnum*17; 			// makes vent height factor of 17
  int ventcenter = (ventrealheight - ventheight)/2; // centers the vents

  ventleft.setXMLParam("y", integerToString(30 + ventcenter));
  ventleft.setXMLParam("h", integerToString(ventheight));
  ventright.setXMLParam("y", integerToString(30 + ventcenter));
  ventright.setXMLParam("h", integerToString(ventheight));

  glowleft.setXMLParam("y", integerToString(30 + ventcenter));
  glowleft.setXMLParam("h", integerToString(ventheight));
  glowright.setXMLParam("y", integerToString(30 + ventcenter));
  glowright.setXMLParam("h", integerToString(ventheight));

}

// *********************** shutter codes **************************
shutter.onLeftButtonUp(int x, int y) {
  shuttertop.setTargetY(-17);
  shutterbottom.setTargetY(17);

  shutter.hide();
  shuttertop.gotoTarget();
  shutterbottom.gotoTarget();

  setPrivateInt("Anunaki", titlebar.getText()+"_ShutterClose", 0);

  shutterclosing = 0;
}

shuttercloser.onLeftButtonUp(int x, int y) {
  shuttertop.setTargetY(0);
  shutterbottom.setTargetY(0);

  shuttertop.gotoTarget();
  shutterbottom.gotoTarget();

  shutterclosing = 1;

  setPrivateInt("Anunaki", titlebar.getText()+"_ShutterClose", 1);
}

shuttertop.onTargetReached() {
  if (shutterclosing) shutter.show();
}

// *********************** volume code **********************
system.onVolumeChanged(int currvol) {
  int frame, intframe;

  frame = currvol*volume.getLength()/255;
  intframe = frame;
  if ((frame-intframe)>0.5) intframe++;
  if ((intframe ==0) && (currvol > 2)) intframe = 1;
  if (intframe>(volume.getLength()-1)) intframe = volume.getLength()-1;
  volume.gotoFrame(intframe);
}

volume.onLeftButtonDown(int x, int y) {
  voladjust = 1;
}

volume.onMouseMove(int x, int y) {
  if (!voladjust) return;

  int newvol = (x-getLeft())*255/getWidth();

  if (newvol < 0) newvol = 0;
  if (newvol > 255) newvol = 255;

  setVolume(newvol);
}

volume.onLeftButtonUp(int x, int y) {
  voladjust = 0;

  int newvol = (x-getLeft())*255/getWidth();

  if (newvol < 0) newvol = 0;
  if (newvol > 255) newvol = 255;

  setVolume(newvol);
}


// *********************** standard-frame beat vis code **********************

beatvisSetAlpha(int left, int right) {
  glowleft.setAlpha(left);
  glowright.setAlpha(right);
}


refreshBeat.onTimer() {
  int vuleft, vuright, x;

  if (visupdating) return;
  visupdating = TRUE;

  if (beatsource == BEAT_VU) {

    vuleft = getLeftVUMeter();
    vuright = getRightVUMeter();

  } else if (beatsource == BEAT_BASS) {

    vuleft = 0;
    vuright = 0;

    for (x=0; x<=4; x++)
    {
      vuleft = vuleft+getVisBand(0,x);
      vuright = vuright+getVisBand(0,x);
    }
    vuleft = vuleft/5;
    vuright = vuright/5;
  } else if (beatsource == BEAT_TREBLE) {

    vuleft = 0;
    vuright = 0;

    for (x=0; x<=5; x++)
    {
      vuleft = vuleft+getVisBand(0,75-x*2);
      vuright = vuright+getVisBand(0,75-x*2);
    }
    vuleft = vuleft/5;
    vuright = vuright/5;
  }

  if (vuleft>maxvu) maxvu = vuleft;
  if (vuright>maxvu) maxvu = vuright;

  vuleft = vuleft/maxvu*255;
  vuright = vuright/maxvu*255;

  int deltaleft = vuleft-lastvuleft;
  int deltaright = vuright-lastvuright;

  if ((deltaleft>0) && (deltaleft>deltaapha)) vuleft = lastvuleft + deltaapha;
  if ((deltaleft<0) && (deltaleft<(-deltaapha))) vuleft = lastvuleft - deltaapha;

  if ((deltaright>0) && (deltaright>deltaapha)) vuright = lastvuright + deltaapha;
  if ((deltaright<0) && (deltaright<(-deltaapha))) vuright = lastvuright - deltaapha;

  if (beatmode == BEAT_ON) {
    beatvisSetAlpha(vuleft, vuright);
  } else if (beatmode == BEAT_REV) {
    beatvisSetAlpha(255-vuleft, 255-vuright);
  }

  lastvuleft = vuleft;
  lastvuright = vuright;

  visupdating = FALSE;
}

ventleft.onRightButtonDown(int x, int y) {
  boolean disablemenu;

  beatvismenu = new popUpMenu;
  beatvismenu.addCommand("- "+titlebar.getText()+" Lights -", -1, 0, 1);
  beatvismenu.addSeparator();
  beatvismenu.addCommand("Off", 0, beatmode==BEAT_OFF, 0);
  beatvismenu.addCommand("Stay On", 1, beatmode==BEAT_STAY, 0);
  beatvismenu.addCommand("Beat (High-CPU)", 2, beatmode==BEAT_ON, 0);
  beatvismenu.addCommand("Reversed Beat (High-CPU)", 3, beatmode==BEAT_REV, 0);

  disablemenu = ((beatmode==BEAT_OFF) || (beatmode==BEAT_STAY));
  beatvismenu.addSeparator();
  beatvismenu.addCommand("- Beat Source -", -1, 0, 1);
  beatvismenu.addSeparator();

  beatvismenu.addCommand("VU Meter", 10, beatsource==BEAT_VU, disablemenu);
  beatvismenu.addCommand("Bass", 11, beatsource==BEAT_BASS, disablemenu);
  beatvismenu.addCommand("Treble", 12, beatsource==BEAT_TREBLE, disablemenu);

  int res = beatvismenu.popAtMouse();
  delete beatvismenu;

  if (res<0) return;

  if (res < 10) {
    beatMode = res;

    setPrivateInt("Anunaki", titlebar.getText()+"_Beat Mode", beatMode);
  } else {
    beatsource = res;

    setPrivateInt("Anunaki", titlebar.getText()+"_Beat Source", beatSource);

  }

  maxvu=15;

  refreshBeat.stop();

  if (beatmode==BEAT_OFF) {
    beatvisSetAlpha(0, 0);
  } else if (beatmode==BEAT_STAY) {
    beatvisSetAlpha(255, 255);
  } else if ((beatmode==BEAT_ON) || (beatmode==BEAT_REV)) {
    refreshBeat.start();
  }

  complete;
}

ventright.onRightButtonDown(int x, int y) {
  ventleft.onRightButtonDown(x, y);
}