/*************************************************************

  Anunaki - togglebuttons.m
  by Leechbite

  - this script controls the repeat,shuffle,xfade temp text
    display

*************************************************************/

#include <lib/std.mi>
#include <lib/config.mi>
#include "temptext.m"

Global group frameGroup;
Global togglebutton buttonSHF, buttonREP, buttonXFD;
Global slider Xfdtime;

System.onScriptLoaded() {
  temptextLoad();

  frameGroup = getScriptGroup();

  buttonSHF = frameGroup.findObject("Shuffle");
  buttonREP = frameGroup.findObject("Repeat");
  buttonXFD = frameGroup.findObject("Xfade");

  layout mainnormal = getContainer("main").getLayout("normal");
  XfdTime = mainnormal.findObject("Xfade.time");
}

system.onScriptUnloading() {
  temptextUnLoad();
  XfdTime = NULL;
}

buttonSHF.onToggle(int on) {
  if (on==1) {
    setTempText("Shuffle On");
  } else {
    setTempText("Shuffle Off");
  }
}

buttonREP.onToggle(int on) {
  int v = getCurCfgVal();
  if (v==0) setTempText("Repeat Off");
  else if (v==1) setTempText("Repeat All");
  else setTempText("Repeat Track");
}

buttonXFD.onActivate(int on) {
  if (on==1) {
    setTempText("Crossfading On");
  } else {
    setTempText("Crossfading Off");
  }
}

buttonREP.onRightButtonDown(int x, int y) {
  popUpMenu repmenu = new popUpMenu;

  int x;
  int repeatmode = getCurCfgVal();

  repmenu.addCommand("- Repeat -", -1, 0, 1);
  repmenu.addSeparator();
  repmenu.addCommand("Repeat Off", 0, (repeatmode==0), 0);
  repmenu.addCommand("Repeat All", 1, (repeatmode==1), 0);
  repmenu.addCommand("Repeat Track", 2, (repeatmode==-1), 0);

  int res = repmenu.popAtMouse();
  delete repmenu;

  complete;

  if (res<0) return;
  if (res==2) res = -1;

  configItem item = Config.getItem("Playlist editor");
  configAttribute attrRepeat = item.getAttribute("repeat");
  attrRepeat.setData(integerToString(res));

  buttonREP.onToggle(res!=0);
}

buttonXFD.onRightButtonDown(int x, int y) {
  popUpMenu xfdmenu = new popUpMenu;

  int x;
  int currFadetime = XfdTime.getPosition();
  boolean XfadeOn = buttonXFD.getActivated()==1;

  xfdmenu.addCommand("- Xfade Time -", -1, 0, 1);
  xfdmenu.addSeparator();
  xfdmenu.addCommand("Off", 0, (currFadetime==0) || (!XfadeOn), 0);

  for (x=1; x<=20; x++) {
    xfdmenu.addCommand(integerToString(x)+" sec", x, (currFadetime==x) && (XfadeOn), 0);
  }

  int res = xfdmenu.popAtMouse();
  delete xfdmenu;

  complete;

  if (res<0) return;
  if (res==0) {
    if (XFadeOn) buttonXFD.leftClick();
  }
  else {
    if (!XFadeOn) buttonXFD.leftClick();
    XfdTime.setPosition(res);
    setTempText("Crossfade Time: "+integerToString(res)+" sec");
  }
}