/*************************************************************

  Anunaki - togglebuttons2.m
  by Leechbite

  - this script controls the repeat,shuffle,xfade temp text
    display. (for Party Mode)

*************************************************************/

#include <lib/std.mi>
#include <lib/config.mi>
#include "temptext.m"

Global group frameGroup;
Global togglebutton buttonSHF, buttonREP, buttonREP2, buttonXFD;
Global slider Xfdtime;

System.onScriptLoaded() {
  temptextLoad();

  frameGroup = getScriptGroup();

  group temp = frameGroup.findObject("Shuffle");
  buttonSHF = temp.getObject("anunaki.button2");
  temp = frameGroup.findObject("Repeat");
  buttonREP = temp.getObject("anunaki.button2");
  temp = frameGroup.findObject("Repeat2");
  buttonREP2 = temp.getObject("anunaki.button2");
  temp = frameGroup.findObject("Xfade");
  buttonXFD = temp.getObject("anunaki.button2");

  layout mainnormal = getContainer("main").getLayout("normal");
  XfdTime = mainnormal.findObject("Xfade.time");
}

system.onScriptUnloading() {
  temptextUnLoad();
  XfdTime = NULL;
}

buttonSHF.onToggle(int on) {
  if (on==1) {
    setTempText("Shuffle On");
  } else {
    setTempText("Shuffle Off");
  }
}

buttonREP.onToggle(int on) {
  if (on==0) setTempText("Repeat Off");
  else if (on==1) setTempText("Repeat Track");
}

buttonREP2.onToggle(int on) {
  if (on==0) setTempText("Repeat Off");
  else if (on==1) setTempText("Repeat All");
}

buttonXFD.onActivate(int on) {
  if (on==1) {
    setTempText("Crossfading On");
  } else {
    setTempText("Crossfading Off");
  }
}

buttonXFD.onRightButtonDown(int x, int y) {
  popUpMenu xfdmenu = new popUpMenu;

  int x;
  int currFadetime = XfdTime.getPosition();
  boolean XfadeOn = buttonXFD.getActivated()==1;

  xfdmenu.addCommand("- Xfade Time -", -1, 0, 1);
  xfdmenu.addSeparator();
  xfdmenu.addCommand("Off", 0, (currFadetime==0) || (!XfadeOn), 0);

  for (x=1; x<=20; x++) {
    xfdmenu.addCommand(integerToString(x)+" sec", x, (currFadetime==x) && (XfadeOn), 0);
  }

  int res = xfdmenu.popAtMouse();
  delete xfdmenu;

  complete;

  if (res<0) return;
  if (res==0) {
    if (XFadeOn) buttonXFD.leftClick();
  }
  else {
    if (!XFadeOn) buttonXFD.leftClick();
    XfdTime.setPosition(res);
    setTempText("Crossfade Time: "+integerToString(res)+" sec");
  }
}