/*************************************************************

  Anunaki - xui-button.m
  by Leechbite

  Anunaki:Button XUI Object Scripts

  added parameters:

    labelText - text label of button. duh!
    iconImage - image id for small icon on button

*************************************************************/

#include <lib/std.mi>

function refreshLabels();

Global group ButtonGroup;
Global group buttonNormal, buttonDown, buttonHover;
Global guiobject realButton;
Global text buttonLabel;
Global layer buttonIcon;
Global boolean mouseOver;

System.onScriptLoaded() {
  ButtonGroup = getScriptGroup();

  buttonNormal = buttonGroup.findObject("anunaki.button.normal");
  buttonDown = buttonGroup.findObject("anunaki.button.down");
  buttonHover = buttonGroup.findObject("anunaki.button.hover");

  realButton = buttonGroup.getObject("anunaki.button");
  buttonLabel = buttonGroup.getObject("anunaki.button.label");
  buttonIcon = buttonGroup.getObject("anunaki.button.icon");

  mouseOver = 0;
}

System.onScriptUnloading() {
  realButton = NULL;  // clears all events
  buttonGroup = NULL;
}

realButton.onLeftButtonDown(int x, int y) {
  buttonDown.show();
  buttonHover.hide();
  buttonNormal.hide();
}

realButton.onLeftButtonUp(int x, int y) {
  buttonDown.hide();
  buttonHover.hide();
  buttonNormal.hide();
  if (mouseOver)
    buttonHover.show();
  else
    buttonNormal.show();
}

realButton.onEnterArea() {
  mouseOver = 1;
  buttonDown.hide();
  buttonHover.show();
  buttonNormal.hide();
}

realButton.onLeaveArea() {
  mouseOver = 0;
  buttonDown.hide();
  buttonHover.hide();
  buttonNormal.show();
}

System.onSetXuiParam(String param, String value) {
  param = system.strlower(param);
  if (param=="labeltext") {
    buttonLabel.setText(value);
    refreshLabels();
  } else if (param=="iconimage") {
    buttonIcon.setXMLParam("image", value);
    refreshLabels();
  } else if (param=="xuitooltip") {
    realButton.setXMLParam("tooltip", value);
  }
}

buttonGroup.onResize(int x, int y, int w, int h) {
  refreshLabels();
}

refreshLabels() {
  int labelwid = buttonLabel.getAutoWidth()+buttonIcon.getAutoWidth();

  int x = (buttonGroup.getWidth() - labelwid)/2;

  if (x<5) x=5;

  buttonIcon.setXMLParam("x", integerToString(x));
  buttonLabel.setXMLParam("x", integerToString(x+buttonIcon.getAutoWidth()));
  buttonLabel.setXMLParam("w", integerToString(-(5+x+buttonIcon.getAutoWidth())));

}