/*************************************************************

  Anunaki - xui-tilelayer.m
  by Leechbite

  Anunaki:TileLayer XUI Object Scripts

*************************************************************/

#include <lib/std.mi>

function refreshLayer();

Global group layerGroup;
Global layer tilelayer;

Global int orgx, orgy, orgw, orgh;
Global int spacex1 = 0, spacex2 = 0, spacey1 = 0, spacey2 = 0;
Global boolean orgrelatx,orgrelaty,orgrelatw,orgrelath;

Global int tilew, tileh;

Global string align, valign;

System.onScriptLoaded() {
  layerGroup = getScriptGroup();
  tilelayer = layerGroup.getObject("anunaki.tilelayer");
}

System.onScriptUnloading() {
  return;
}

System.onSetXuiParam(String param, String value) {
  param = strlower(param);

  if (param == "spacex1") spacex1 = stringToInteger(value);
  if (param == "spacex2") spacex2 = stringToInteger(value);
  if (param == "spacey1") spacey1 = stringToInteger(value);
  if (param == "spacey2") spacey2 = stringToInteger(value);

  if (param == "align") align = strlower(value);
  if (param == "valign") valign = strlower(value);

  if (param == "tilew") tilew = stringToInteger(value);
  if (param == "tileh") tileh = stringToInteger(value);

  if (param == "tilemove") tilelayer.setXMLParam("move", value);
  if (param == "tileghost") tilelayer.setXMLParam("ghost", value);

  refreshLayer();
}

layerGroup.onResize(int x, int y, int w, int h) {
  refreshLayer();
}

refreshLayer() {

  tilelayer.setXMLParam("x", "0");
  tilelayer.setXMLParam("y", "0");
  tilelayer.setXMLParam("w", "0");
  tilelayer.setXMLParam("h", "0");
  tilelayer.setXMLParam("relatx", "0");
  tilelayer.setXMLParam("relaty", "0");
  tilelayer.setXMLParam("relatw", "1");
  tilelayer.setXMLParam("relath", "1");

  int parentwidth = layerGroup.getWidth();

  int numtilew = 0;
  if (tilew!=0)
    numtilew = parentwidth/tilew;

  int idealw = numtilew*tilew - spacex2;
  int diffw = parentwidth - idealw;

  if (align == "center") {
    tilelayer.setXMLParam("x",integerToString((diffw-spacex1)/2));
    tilelayer.setXMLParam("w",integerToString(-diffw));
  } else if (align == "right") {
    tilelayer.setXMLParam("x",integerToString(diffw));
    tilelayer.setXMLParam("w",integerToString(-diffw));
  } else { // if align is left (Default)
    tilelayer.setXMLParam("x",integerToString(-spacex1));
    tilelayer.setXMLParam("w",integerToString(-diffw));
  }

  int parentheight = layerGroup.getHeight();

  int numtileh = 0;
  if (tileh!=0)
    numtileh = parentheight/tileh;

  int idealh = numtileh*tileh - spacey2;
  int diffh = parentheight - idealh;

  if (valign == "center") {
    tilelayer.setXMLParam("y",integerToString((diffh-spacey1)/2));
    tilelayer.setXMLParam("h",integerToString(-diffh));
  } else if (valign == "bottom") {
    tilelayer.setXMLParam("y",integerToString(diffh));
    tilelayer.setXMLParam("h",integerToString(-diffh));
  } else { // if valign is top (Default)
    tilelayer.setXMLParam("y",integerToString(-spacey1));
    tilelayer.setXMLParam("h",integerToString(-diffh));
  }
}


